/**
* BY: haole zheng
* http://passer-by.com
*/
!function (root, factory) {
    if (typeof module === 'object' && module.exports){
        module.exports = factory();
    }else{
        root.relationship = factory();
    }
}(typeof window !== 'undefined' ? window : this,function (){
    //简写
    var _filter = [
        /* 年龄 */
        {//有大有小，增加不确定性
            exp:/^(.+)&o([^#]+)&l/g,
            str:'$1$2'
        },
        {//有大有小，增加不确定性
            exp:/^(.+)&l([^#]+)&o/g,
            str:'$1$2'
        },
        {//有大有小，增加不确定性
            exp:/^(.+)?,o([sb])([^#]+)&l/g,
            str:'$1,x$2$3'
        },
        {//有大有小，增加不确定性
            exp:/^(.+)?,l([sb])([^#]+)&o/g,
            str:'$1,x$2$3'
        },
        {//隔代跨越，增加不确定性
            exp:/(,[ds],(.+),[ds])&[ol]/g,
            str:'$1'
        },
        /* 兄弟姐妹 */
        {//哥哥姐姐的哥哥姐姐还是自己的哥哥姐姐(年龄判断)
            exp:/(,o[sb])+(,o[sb])/,
            str:'$2'
        },
        {//弟弟妹妹的弟弟妹妹还是自己的弟弟妹妹(年龄判断)
            exp:/(,l[sb])+(,l[sb])/,
            str:'$2'
        },
        {//如果自己是男性,兄弟姐妹的兄弟就是自己的兄弟或自己
            exp:/^(.*)(,[fh1])(,[olx][sb])+,[olx]b(.*)$/,
            str:'$1$2,xb$4#$1$2$4'
        },
        {//如果自己是女性,兄弟姐妹的姐妹就是自己的姐妹或自己
            exp:/^(.*)(,[mw0])(,[olx][sb])+,[olx]s(.*)$/,
            str:'$1$2,xs$4#$1$2$4'
        },
        {//如果自己是男性,兄弟姐妹的姐妹就是自己的姐妹
            exp:/(,[fh1])(,[olx][sb])+,[olx]s/g,
            str:'$1,xs'
        },
        {//如果自己是女性,兄弟姐妹的兄弟就是自己的兄弟
            exp:/(,[mw0])(,[olx][sb])+,[olx]b/g,
            str:'$1,xb'
        },
        {//不知道性别，兄弟姐妹的兄弟是自己或兄弟
            exp:/^,[olx][sb],[olx]b(.+)?$/,
            str:'$1#,xb$1'
        },
        {//不知道性别，兄弟姐妹的姐妹是自己或姐妹
            exp:/^,[olx][sb],[olx]s(.+)?$/,
            str:'$1#,xs$1'
        },
        {//将复合称谓拆分
            exp:/^,x([sb])$/,
            str:',o$1#,l$1'
        },
        /* 父母 */
        {//母亲的丈夫是自己的父亲
            exp:/m,h/g,
            str:'f'
        },
        {//父亲的妻子是自己的母亲
            exp:/f,w/g,
            str:'m'
        },
        {//兄弟的父母就是自己的父母
            exp:/,[xol][sb](,[mf])/g,
            str:'$1'
        },
        /* 父母的子女 */
        {//父母的女儿年龄判断是姐姐还是妹妹
            exp:/,[mf],d&([ol])/,
            str:',$1s'
        },
        {//父母的儿子年龄判断是哥哥还是弟弟
            exp:/,[mf],s&([ol])/,
            str:',$1b'
        },
        {//如果自己是男性,父母的儿子是自己或者兄弟
            exp:/^(.*)(,[fh1]|[xol]b),[mf],s(.*)$/,
            str:'$1$2,xb$3#$1$2$3'
        },
        {//如果自己是女性,父母的女儿是自己或者姐妹
            exp:/^(.*)(,[mw0]|[xol]s),[mf],d(.*)$/,
            str:'$1$2,xs$3#$1$2$3'
        },
        {//如果自己是女性,父母的儿子是自己兄弟
            exp:/(,[mw0]|[xol]s),[mf],s/,
            str:'$1,xb'
        },
        {//如果自己是男性,父母的女儿是自己姐妹
            exp:/(,[fh1]|[xol]b),[mf],d/,
            str:'$1,xs'
        },
        {//父母的儿子是自己或兄弟
            exp:/^,[mf],s(.+)?$/,
            str:',1$1#,xb$1'
        },
        {//父母的女儿是自己或者姐妹
            exp:/^,[mf],d(.+)?$/,
            str:',0$1#,xs$1'
        },
        /* 孩子 */
        {//孩子的姐妹是自己的女儿(年龄判断)
            exp:/,[ds]&o,ob/g,
            str:',s&o'
        },
        {//孩子的姐妹是自己的女儿(年龄判断)
            exp:/,[ds]&o,os/g,
            str:',d&o'
        },
        {//孩子的兄弟是自己的儿子(年龄判断)
            exp:/,[ds]&l,lb/g,
            str:',s&l'
        },
        {//孩子的兄弟是自己的儿子(年龄判断)
            exp:/,[ds]&l,ls/g,
            str:',d&l'
        },
        {//孩子的姐妹是自己的女儿
            exp:/,[ds](&[ol])?,[olx]s/g,
            str:',d'
        },
        {//孩子的兄弟是自己的儿子
            exp:/,[ds](&[ol])?,[olx]b/g,
            str:',s'
        },
        /* 夫妻 */
        {//自己是女性，女儿或儿子的妈妈是自己
            exp:/(,[mwd0](&[ol])?|[olx]s),[ds](&[ol])?,m/g,
            str:'$1'
        },
        {//自己是女性，女儿或儿子的爸爸是自己的丈夫
            exp:/(,[mwd0](&[ol])?|[olx]s),[ds](&[ol])?,f/g,
            str:'$1,h'
        },
        {//自己是男性，女儿或儿子的爸爸是自己
            exp:/(,[fhs1](&[ol])?|[olx]b),[ds](&[ol])?,f/g,
            str:'$1'
        },
        {//自己是男性，女儿或儿子的妈妈是自己的妻子
            exp:/(,[fhs1](&[ol])?|[olx]b),[ds](&[ol])?,m/g,
            str:'$1,w'
        },
        {//不知道性别，子女的妈妈是自己或妻子
            exp:/^,[ds],m(.+)?$/,
            str:'$1#,w$1'
        },
        {//不知道性别，子女的爸爸是自己或丈夫
            exp:/^,[ds],f(.+)?$/,
            str:'$1#,h$1'
        },
        {//夫妻的孩子就是自己的孩子
            exp:/,[wh](,[ds])/g,
            str:'$1'
        },
        {//夫妻的对方是自己
            exp:/,w,h|,h,w/g,
            str:''
        },
        {//并列关系处理1 X[A|B|C]Y = XAY#X[B|C]Y
            exp:/(.+)?\[([^\|]+?)\|([^\[\]]*\|[^\[\]]*)\](.+)?/g,
            str:'$1$2$4#$1[$3]$4'
        },
        {//并列关系处理2 X[A|B]Y = XAY#XBY
            exp:/(.+)?\[([^\[\]\|]+?)\|([^\[\]\|]+?)?\](.+)?/g,
            str:'$1$2$4#$1$3$4'
        }
    ];

    //关系数据
    //语法说明：
    //【关系】f:父,m:母,h:夫,w:妻,s:子,d:女,xb:兄弟,ob:兄,lb:弟,xs:姐妹,os:姐,ls:妹
    //【修饰符】 1:男性,0:女性,&o:年长,&l:年幼,#:隔断,[a|b]:并列
    var _map = {
        '':['自己','我','本人','在下'],
        //并称
        '[f,f|f,m|m,f|m,m]':['祖辈','祖父母'],
        '[f|m]':['父母','爹娘','爹妈','爸妈','双亲','二亲','两亲','二老','高堂'],
        '[h,f|h,m]':['公婆'],
        '[w,f|w,m]':['岳父母'],
        '[xb|xs]':['兄弟姐妹','同胞','手足'],
        '[f,xb,s&o|f,xb,s&l]':['堂兄弟'],
        '[f,xb,d&o|f,xb,d&l]':['堂姐妹'],
        '[m,xs,s&o|m,xs,s&l]':['姨兄弟'],
        '[m,xs,d&o|m,xs,d&l]':['姨姐妹'],
        '[f,xs,s&o|f,xs,s&l|m,xb,s&o|m,xb,s&l]':['表兄弟'],
        '[f,xs,d&o|f,xs,d&l|m,xb,d&o|m,xb,d&l]':['表姐妹'],
        '[s|d]':['子女','儿女','小孩','孩子','孩儿','宝宝','娃'],
        '[s,s|s,d|d,s|d,d]':['孙辈'],
        // 本家
        'f':['爸爸','父亲','老爸','阿爸','老窦','爸','父','爹','爹爹','爹地','爹啲','老爹','大大','老爷子'],
        // 爷爷
        'f,f':['爷爷','祖父','奶爷','阿爷','阿公','吖爷','老爷'],
        'f,f,f':['曾祖父','曾祖','太公','太爷','太爷爷','祖公','祖奶爷','太老爷'],
        'f,f,f,f':['高祖父','老太奶爷','老太爷','祖太爷','祖太爷爷','祖太公','高王父'],
        'f,f,f,f,f':['天祖父','高祖'],
        'f,f,f,f,f,f':['烈祖父','烈祖'],
        'f,f,f,f,f,f,f':['太祖父','太祖'],
        'f,f,f,f,f,f,f,f':['远祖父','远祖'],
        'f,f,f,f,f,f,f,f,f':['鼻祖父','鼻祖','始祖'],
        'f,f,f,f,f,f,f,f,f,ob':['伯鼻祖父'],
        'f,f,f,f,f,f,f,f,f,ob,w':['伯鼻祖母'],
        'f,f,f,f,f,f,f,f,f,lb':['叔鼻祖父'],
        'f,f,f,f,f,f,f,f,f,lb,w':['叔鼻祖母'],
        'f,f,f,f,f,f,f,f,f,xs':['姑鼻祖母'],
        'f,f,f,f,f,f,f,f,f,xs,h':['姑鼻祖父'],
        'f,f,f,f,f,f,f,f,m':['鼻祖母'],
        'f,f,f,f,f,f,f,f,m,xb':['舅鼻祖父'],
        'f,f,f,f,f,f,f,f,m,xb,w':['舅鼻祖母'],
        'f,f,f,f,f,f,f,f,m,xs':['姨鼻祖母'],
        'f,f,f,f,f,f,f,f,m,xs,h':['姨鼻祖父'],
        'f,f,f,f,f,f,f,f,ob':['伯远祖父'],
        'f,f,f,f,f,f,f,f,ob,w':['伯远祖母'],
        'f,f,f,f,f,f,f,f,lb':['叔远祖父'],
        'f,f,f,f,f,f,f,f,lb,w':['叔远祖母'],
        'f,f,f,f,f,f,f,f,xs':['姑远祖母'],
        'f,f,f,f,f,f,f,f,xs,h':['姑远祖父'],
        'f,f,f,f,f,f,f,m':['远祖母'],
        'f,f,f,f,f,f,f,m,xb':['舅远祖父'],
        'f,f,f,f,f,f,f,m,xb,w':['舅远祖母'],
        'f,f,f,f,f,f,f,m,xs':['姨远祖母'],
        'f,f,f,f,f,f,f,m,xs,h':['姨远祖父'],
        'f,f,f,f,f,f,f,ob':['伯太祖父'],
        'f,f,f,f,f,f,f,ob,w':['伯太祖母'],
        'f,f,f,f,f,f,f,lb':['叔太祖父'],
        'f,f,f,f,f,f,f,lb,w':['叔太祖母'],
        'f,f,f,f,f,f,f,xs':['姑太祖母'],
        'f,f,f,f,f,f,f,xs,h':['姑太祖父'],
        'f,f,f,f,f,f,m':['太祖母'],
        'f,f,f,f,f,f,m,xb':['舅太祖父'],
        'f,f,f,f,f,f,m,xb,w':['舅太祖母'],
        'f,f,f,f,f,f,m,xs':['姨太祖母'],
        'f,f,f,f,f,f,m,xs,h':['姨太祖父'],
        'f,f,f,f,f,f,ob':['伯烈祖父'],
        'f,f,f,f,f,f,ob,w':['伯烈祖母'],
        'f,f,f,f,f,f,lb':['叔烈祖父'],
        'f,f,f,f,f,f,lb,w':['叔烈祖母'],
        'f,f,f,f,f,f,xs':['姑烈祖母'],
        'f,f,f,f,f,f,xs,h':['姑烈祖父'],
        'f,f,f,f,f,m':['烈祖母'],
        'f,f,f,f,f,m,xb':['舅烈祖父'],
        'f,f,f,f,f,m,xb,w':['舅烈祖母'],
        'f,f,f,f,f,m,xs':['姨烈祖母'],
        'f,f,f,f,f,m,xs,h':['姨烈祖父'],
        'f,f,f,f,f,ob':['伯天祖父'],
        'f,f,f,f,f,ob,w':['伯天祖母'],
        'f,f,f,f,f,lb':['叔天祖父'],
        'f,f,f,f,f,lb,w':['叔天祖母'],
        'f,f,f,f,f,xs':['姑天祖母'],
        'f,f,f,f,f,xs,h':['姑天祖父'],
        'f,f,f,f,m':['天祖母'],
        'f,f,f,f,m,xb':['舅天祖父'],
        'f,f,f,f,m,xb,w':['舅天祖母'],
        'f,f,f,f,m,xs':['姨天祖母'],
        'f,f,f,f,m,xs,h':['姨天祖父'],
        'f,f,f,f,ob':['伯高祖父'],
        'f,f,f,f,ob,w':['伯高祖母'],
        'f,f,f,f,lb':['叔高祖父'],
        'f,f,f,f,lb,w':['叔高祖母'],
        'f,f,f,f,xb,s&o':['堂曾伯祖父'],
        'f,f,f,f,xb,s&o,w':['堂曾伯祖母'],
        'f,f,f,f,xb,s&l':['堂曾叔祖父'],
        'f,f,f,f,xb,s&l,w':['堂曾叔祖母'],
        'f,f,f,f,xb,s,s&o':['从堂伯祖父'],
        'f,f,f,f,xb,s,s&o,w':['从堂伯祖母'],
        'f,f,f,f,xb,s,s&l':['从堂叔祖父'],
        'f,f,f,f,xb,s,s&l,w':['从堂叔祖母'],
        'f,f,f,f,xb,s,d':['从堂姑祖母'],
        'f,f,f,f,xb,s,d,h':['从堂姑祖父'],
        'f,f,f,f,xb,s,s,s&o':['再从堂伯父'],
        'f,f,f,f,xb,s,s,s&o,w':['再从堂伯母'],
        'f,f,f,f,xb,s,s,s&l':['再从堂叔父'],
        'f,f,f,f,xb,s,s,s&l,w':['再从堂叔母'],
        'f,f,f,f,xb,s,s,d':['再从堂姑母'],
        'f,f,f,f,xb,s,s,d,h':['再从堂姑父'],
        'f,f,f,f,xb,s,s,s,s&o':['三从堂兄'],
        'f,f,f,f,xb,s,s,s,s&o,w':['三从堂嫂'],
        'f,f,f,f,xb,s,s,s,s&l':['三从堂弟'],
        'f,f,f,f,xb,s,s,s,s&l,w':['三从堂弟媳'],
        'f,f,f,f,xb,s,s,s,d&o':['三从堂姐'],
        'f,f,f,f,xb,s,s,s,d&o,h':['三从堂姐夫'],
        'f,f,f,f,xb,s,s,s,d&l':['三从堂妹'],
        'f,f,f,f,xb,s,s,s,d&l,h':['三从堂妹夫'],
        'f,f,f,f,xb,d':['堂曾姑祖母'],
        'f,f,f,f,xb,d,h':['堂曾姑祖父'],
        'f,f,f,f,xs':['姑高祖母'],
        'f,f,f,f,xs,h':['姑高祖父'],
        'f,f,f,m':['高祖母','老太奶奶','老太太','祖太太','祖太奶','祖太奶奶','祖太婆','高王母'],
        'f,f,f,m,xb':['舅高祖父'],
        'f,f,f,m,xb,w':['舅高祖母'],
        'f,f,f,m,xs':['姨高祖母'],
        'f,f,f,m,xs,h':['姨高祖父'],
        // 从父*
        'f,f,f,ob':['伯曾祖父','曾伯祖父','曾伯父','太伯公','伯公太','伯太爷','伯公老爷','族曾祖父'],
        'f,f,f,ob,w':['伯曾祖母','曾伯祖母','曾伯母','太公婆','伯婆太','伯太太','伯婆奶奶','族曾祖母'],
        'f,f,f,lb':['叔曾祖父','曾叔祖父','曾叔父','太叔公','叔公太','叔太爷','叔公老爷','族曾祖父'],
        'f,f,f,lb,w':['叔曾祖母','曾叔祖母','曾叔母','太叔婆','叔婆太','叔太太','叔婆奶奶','族曾祖母'],
        // 再从父
        'f,f,f,xb,s&o':['堂伯祖父','从父伯祖父','叔伯伯祖父','族伯祖父','族祖父'],
        'f,f,f,xb,s&o,w':['堂伯祖母','从父伯祖母','叔伯伯祖母','族伯祖母','族祖母'],
        'f,f,f,xb,s&l':['堂叔祖父','从父叔祖父','叔伯叔祖父','族叔祖父','族祖父'],
        'f,f,f,xb,s&l,w':['堂叔祖母','从父叔祖母','叔伯叔祖母','族叔祖母','族祖母'],
        'f,f,f,xb,s,s&o':['从堂伯父','再从父伯父','叔伯叔伯伯父','再从伯父','族伯父','族父'],
        'f,f,f,xb,s,s&o,w':['从堂伯母','再从父伯母','叔伯叔伯伯母','再从伯母','族伯母','族母'],
        'f,f,f,xb,s,s&l':['从堂叔父','再从父叔父','叔伯叔伯叔父','再从叔父','族叔父','族父'],
        'f,f,f,xb,s,s&l,w':['从堂叔母','再从父叔母','叔伯叔伯叔母','再从叔母','族叔母','族母'],
        'f,f,f,xb,s,s,s&o':['再从堂兄','三从父兄','族兄'],
        'f,f,f,xb,s,s,s&o,w':['再从堂嫂','三从父嫂','族嫂'],
        'f,f,f,xb,s,s,s&l':['再从堂弟','三从父弟','族弟'],
        'f,f,f,xb,s,s,s&l,w':['再从堂弟媳','三从父弟媳','族弟媳'],
        'f,f,f,xb,s,s,s,s':['再从堂侄','三从父侄子','族侄子'],
        'f,f,f,xb,s,s,s,s,w':['再从堂侄媳','三从父侄媳','族侄媳'],
        'f,f,f,xb,s,s,s,s,s':['再从堂侄孙','三从父侄孙','族侄孙'],
        'f,f,f,xb,s,s,s,s,s,w':['再从堂侄孙媳','三从父侄孙媳','族侄孙媳'],
        'f,f,f,xb,s,s,s,s,d':['再从堂侄孙女','三从父侄孙女','族侄孙女'],
        'f,f,f,xb,s,s,s,s,d,h':['再从堂侄孙婿','三从父侄孙婿','族侄孙婿'],
        'f,f,f,xb,s,s,s,d':['再从堂侄女','三从父侄女','族侄女'],
        'f,f,f,xb,s,s,s,d,h':['再从堂侄女婿','三从父侄婿','族侄女婿'],
        'f,f,f,xb,s,s,s,d,s':['再从堂侄外孙','三从父侄外孙','族侄外孙'],
        'f,f,f,xb,s,s,s,d,s,w':['再从堂侄外孙媳','三从父侄外孙媳','族侄外孙媳'],
        'f,f,f,xb,s,s,s,d,d':['再从堂侄外孙女','三从父侄外孙女','族侄外孙女'],
        'f,f,f,xb,s,s,s,d,d,h':['再从堂侄外孙婿','三从父侄外孙婿','族侄外孙婿'],
        'f,f,f,xb,s,s,d&o':['再从堂姐','三从父姐','族姐'],
        'f,f,f,xb,s,s,d&o,h':['再从堂姐夫','三从父姐夫','族姐夫'],
        'f,f,f,xb,s,s,d&l':['再从堂妹','三从父妹','族妹'],
        'f,f,f,xb,s,s,d&l,h':['再从堂妹夫','三从父妹夫','族妹夫'],
        'f,f,f,xb,s,s,d,s':['再从堂外甥','三从父外甥','族外甥'],
        'f,f,f,xb,s,s,d,s,w':['再从堂外甥媳','三从父外甥媳','族外甥媳'],
        'f,f,f,xb,s,s,d,d':['再从堂外甥女','三从父外甥女','族外甥女'],
        'f,f,f,xb,s,s,d,d,h':['再从堂外甥婿','三从父外甥婿','族外甥婿'],
        'f,f,f,xb,s,d':['从堂姑母','再从父姑母','叔伯叔伯姑母','再从姑母','族姑母','族姑'],
        'f,f,f,xb,s,d,h':['从堂姑父','再从父姑父','叔伯叔伯姑父','再从姑父','族姑父','族姑父'],
        // 从父姑表
        'f,f,f,xb,d':['堂姑祖母','从父姑祖母'],
        'f,f,f,xb,d,h':['堂姑祖父','从父姑祖父'],
        'f,f,f,xb,d,s&o':['堂姑表伯父','从父姑表伯父'],
        'f,f,f,xb,d,s&o,w':['堂姑表伯母','从父姑表伯母'],
        'f,f,f,xb,d,s&l':['堂姑表叔父','从父姑表叔父'],
        'f,f,f,xb,d,s&l,w':['堂姑表叔母','从父姑表叔母'],
        'f,f,f,xb,d,d':['堂姑表姑母','从父姑表姑母'],
        'f,f,f,xb,d,d,h':['堂姑表姑父','从父姑表姑父'],
        // 姑表*
        'f,f,f,xs':['姑曾祖母','曾祖姑母','太姑婆','姑婆太','姑太太','曾祖姑','姑婆奶奶'],
        'f,f,f,xs,h':['姑曾祖父','曾祖姑丈','太姑丈公','姑丈公太','姑太爷','姑公老爷'],
        // 姑表叔表
        'f,f,f,xs,s&o':['姑表伯祖父'],
        'f,f,f,xs,s&o,w':['姑表伯祖母'],
        'f,f,f,xs,s&l':['姑表叔祖父'],
        'f,f,f,xs,s&l,w':['姑表叔祖母'],
        'f,f,f,xs,s,s&o':['姑表叔表伯父'],
        'f,f,f,xs,s,s&o,w':['姑表叔表伯母'],
        'f,f,f,xs,s,s&l':['姑表叔表叔父'],
        'f,f,f,xs,s,s&l,w':['姑表叔表叔母'],
        'f,f,f,xs,s,d':['姑表叔表姑母'],
        'f,f,f,xs,s,d,h':['姑表叔表姑父'],
        // 姑表姑表
        'f,f,f,xs,d':['姑表姑祖母'],
        'f,f,f,xs,d,h':['姑表姑祖父'],
        'f,f,f,xs,d,s&o':['姑表姑表伯父'],
        'f,f,f,xs,d,s&o,w':['姑表姑表伯母'],
        'f,f,f,xs,d,s&l':['姑表姑表叔父'],
        'f,f,f,xs,d,s&l,w':['姑表姑表叔母'],
        'f,f,f,xs,d,d':['姑表姑表姑母'],
        'f,f,f,xs,d,d,h':['姑表姑表姑父'],
        'f,f,m':['曾祖母','太婆','祖婆','太奶奶','祖奶奶'],
        'f,f,m,f':['高外祖父','老太姥爷','祖太姥爷','祖太公','高王父'],
        'f,f,m,m':['高外祖母','老太姥姥','祖太姥姥','祖太姥娘','祖太婆','高王母'],
        // 舅表*
        'f,f,m,xb':['舅曾祖父','太舅公','太舅爷','舅太爷','舅太爷爷','舅公老爷'],
        'f,f,m,xb,w':['舅曾祖母','太舅婆','舅太太','舅太奶奶','舅婆奶奶'],
        // 舅表叔表
        'f,f,m,xb,s&o':['舅表伯祖父'],
        'f,f,m,xb,s&o,w':['舅表伯祖母'],
        'f,f,m,xb,s&l':['舅表叔祖父'],
        'f,f,m,xb,s&l,w':['舅表叔祖母'],
        'f,f,m,xb,s,s&o':['舅表叔表伯父'],
        'f,f,m,xb,s,s&o,w':['舅表叔表伯母'],
        'f,f,m,xb,s,s&l':['舅表叔表叔父'],
        'f,f,m,xb,s,s&l,w':['舅表叔表叔母'],
        'f,f,m,xb,s,d':['舅表叔表姑母'],
        'f,f,m,xb,s,d,h':['舅表叔表姑父'],
        // 舅表姑表
        'f,f,m,xb,d':['舅表姑祖母'],
        'f,f,m,xb,d,h':['舅表姑祖父'],
        'f,f,m,xb,d,s&o':['舅表姑表伯父'],
        'f,f,m,xb,d,s&o,w':['舅表姑表伯母'],
        'f,f,m,xb,d,s&l':['舅表姑表叔父'],
        'f,f,m,xb,d,s&l,w':['舅表姑表叔母'],
        'f,f,m,xb,d,d':['舅表姑表姑母'],
        'f,f,m,xb,d,d,h':['舅表姑表姑父'],
        // 从母*
        'f,f,m,xs':['姨曾祖母','太姨奶','姨太太','曾姨奶奶','姨太奶奶','姨婆奶奶'],
        'f,f,m,xs,h':['姨曾祖父','太姨爷','姨太爷','姨太爷爷'],
        // 从母叔表
        'f,f,m,xs,s&o':['从母伯祖父'],
        'f,f,m,xs,s&o,w':['从母伯祖母'],
        'f,f,m,xs,s&l':['从母叔祖父'],
        'f,f,m,xs,s&l,w':['从母叔祖母'],
        'f,f,m,xs,s,s&o':['从母叔表伯父'],
        'f,f,m,xs,s,s&o,w':['从母叔表伯母'],
        'f,f,m,xs,s,s&l':['从母叔表叔父'],
        'f,f,m,xs,s,s&l,w':['从母叔表叔母'],
        'f,f,m,xs,s,d':['从母叔表姑母'],
        'f,f,m,xs,s,d,h':['从母叔表姑父'],
        // 从母姑表
        'f,f,m,xs,d':['从母姑祖母'],
        'f,f,m,xs,d,h':['从母姑祖父'],
        'f,f,m,xs,d,s&o':['从母姑表伯父'],
        'f,f,m,xs,d,s&o,w':['从母姑表伯母'],
        'f,f,m,xs,d,s&l':['从母姑表叔父'],
        'f,f,m,xs,d,s&l,w':['从母姑表叔母'],
        'f,f,m,xs,d,d':['从母姑表姑母'],
        'f,f,m,xs,d,d,h':['从母姑表姑父'],
        // 从父*
        'f,f,ob':['伯公','伯祖父','伯老爷','大爷爷','大爷','堂祖父','伯爷爷'],
        'f,f,ob,w':['伯婆','伯祖母','伯奶奶','大奶奶','堂祖母','姆婆'],
        'f,f,lb':['叔公','叔祖父','叔老爷','小爷爷','堂祖父','叔爷爷','叔奶爷'],
        'f,f,lb,w':['叔婆','叔祖母','叔奶奶','小奶奶','堂祖母','婶婆'],
        'f,f,xb':['堂祖父','从祖祖父','从祖父','x爷爷','x大爷'],
        'f,f,xb,w':['堂祖母','从祖祖母','从祖母'],
        // 再从父
        'f,f,xb,s&o':['堂伯','堂伯父','从父伯父','叔伯伯'],
        'f,f,xb,s&o,w':['堂伯母','从父伯母'],
        'f,f,xb,s&l':['堂叔','堂叔父','从父叔父','叔伯叔父','叔伯叔'],
        'f,f,xb,s&l,w':['堂婶','堂叔母','堂婶母','从父叔母','叔伯叔母'],
        'f,f,xb,s,s&o':['从堂兄','再从父兄','再从兄','从祖兄'],
        'f,f,xb,s,s&o,w':['从堂嫂','再从父嫂','再从嫂'],
        'f,f,xb,s,s&l':['从堂弟','再从父弟','再从弟','从祖弟'],
        'f,f,xb,s,s&l,w':['从堂弟媳','从堂弟媳','再从父弟媳'],
        'f,f,xb,s,s,s':['从堂侄','再从父侄男'],
        'f,f,xb,s,s,s,w':['从堂侄媳','再从父侄媳'],
        'f,f,xb,s,s,s,s':['从堂侄孙','再从父侄孙'],
        'f,f,xb,s,s,s,s,w':['从堂侄孙媳','再从父侄孙媳'],
        'f,f,xb,s,s,s,d':['从堂侄孙女','再从父侄孙女'],
        'f,f,xb,s,s,s,d,h':['从堂侄孙女婿','再从父侄孙女婿'],
        'f,f,xb,s,s,d':['从堂侄女','再从父侄女'],
        'f,f,xb,s,s,d,h':['从堂侄婿','再从父侄婿'],
        'f,f,xb,s,s,d,s':['从堂侄外孙','再从父侄外孙'],
        'f,f,xb,s,s,d,s,w':['从堂侄外孙媳','再从父侄外孙媳'],
        'f,f,xb,s,s,d,d':['从堂侄外孙女','再从父外侄孙女'],
        'f,f,xb,s,s,d,d,h':['从堂侄外孙女婿','再从父外侄孙女婿'],
        'f,f,xb,s,d&o':['从堂姐','再从父姐','从祖姐'],
        'f,f,xb,s,d&o,h':['从堂姐夫','再从父姐夫'],
        'f,f,xb,s,d&l':['从堂妹','再从父妹','从祖妹'],
        'f,f,xb,s,d&l,h':['从堂妹夫','再从父妹夫'],
        'f,f,xb,s,d,s':['从堂外甥','再从父外甥'],
        'f,f,xb,s,d,s,w':['从堂外甥媳','再从父外甥媳'],
        'f,f,xb,s,d,d':['从堂外甥女','再从父外甥女'],
        'f,f,xb,s,d,d,h':['从堂甥女婿','再从父甥女婿'],
        // 从父姑表
        'f,f,xb,d':['堂姑','堂姑妈','堂姑母','从父姑母','叔伯姑母','叔伯姑'],
        'f,f,xb,d,h':['堂姑丈','堂姑爸','堂姑父','从父姑父','叔伯姑父'],
        'f,f,xb,d,s&o':['堂姑表哥','从父姑表哥'],
        'f,f,xb,d,s&o,w':['堂姑表嫂','从父姑表嫂'],
        'f,f,xb,d,s&l':['堂姑表弟','从父姑表弟'],
        'f,f,xb,d,s&l,h':['堂姑表弟媳','从父姑表弟媳'],
        'f,f,xb,d,s,s':['堂姑表侄男','从父姑表侄男'],
        'f,f,xb,d,s,s,w':['堂姑表侄妇','从父姑表侄妇'],
        'f,f,xb,d,s,d':['堂姑表侄女','从父姑表侄女'],
        'f,f,xb,d,s,d,h':['堂姑表侄婿','从父姑表侄婿'],
        'f,f,xb,d,d&o':['堂姑表姐','从父姑表姐'],
        'f,f,xb,d,d&o,h':['堂姑表姐夫','从父姑表姐夫'],
        'f,f,xb,d,d&l':['堂姑表妹','从父姑表妹'],
        'f,f,xb,d,d&l,h':['堂姑表妹夫','从父姑表妹夫'],
        'f,f,xb,d,d,s':['堂姑表甥男','从父姑表甥男'],
        'f,f,xb,d,d,s,w':['堂姑表甥妇','从父姑表甥妇'],
        'f,f,xb,d,d,d':['堂姑表甥女','从父姑表甥女'],
        'f,f,xb,d,d,d,h':['堂姑表甥婿','从父姑表甥婿'],
        // 姑表*
        'f,f,xs':['姑奶奶','姑内祖母','祖姑母','姑祖母','姑奶','姑婆','祖姑'],
        'f,f,xs,h':['姑爷爷','姑内祖父','祖姑父','姑祖父','姑老爷','姑公','姑奶爷','姑丈公'],
        // 姑表叔表
        'f,f,xs,s&o':['姑表伯父','表伯父','表伯'],
        'f,f,xs,s&o,w':['姑表伯母','表伯母'],
        'f,f,xs,s&l':['姑表叔父','表叔父','表叔爸','表叔'],
        'f,f,xs,s&l,w':['姑表叔母','表叔母','表叔妈','表婶'],
        'f,f,xs,s,s&o':['姑表叔表哥'],
        'f,f,xs,s,s&o,w':['姑表叔表嫂'],
        'f,f,xs,s,s&l':['姑表叔表弟'],
        'f,f,xs,s,s&l,w':['姑表叔表弟媳'],
        'f,f,xs,s,s,s':['姑表叔表侄男'],
        'f,f,xs,s,s,s,w':['姑表叔表侄妇'],
        'f,f,xs,s,s,d':['姑表叔表侄女'],
        'f,f,xs,s,s,d,h':['姑表叔表侄婿'],
        'f,f,xs,s,d&o':['姑表叔表姐'],
        'f,f,xs,s,d&o,h':['姑表叔表姐夫'],
        'f,f,xs,s,d&l':['姑表叔表妹'],
        'f,f,xs,s,d&l,h':['姑表叔表妹夫'],
        'f,f,xs,s,d,s':['姑表叔表甥男'],
        'f,f,xs,s,d,s,w':['姑表叔表甥妇'],
        'f,f,xs,s,d,d':['姑表叔表甥女'],
        'f,f,xs,s,d,d,h':['姑表叔表甥婿'],
        // 姑表姑表
        'f,f,xs,d':['姑表姑母','表姑妈','表姑母','表姑姑','表姑'],
        'f,f,xs,d,h':['姑表姑父','表姑爸','表姑父','表姑丈'],
        'f,f,xs,d,s&o':['堂姑表表哥','姑表姑表哥'],
        'f,f,xs,d,s&o,w':['堂姑表表嫂','姑表姑表嫂'],
        'f,f,xs,d,s&l':['堂姑表表弟','姑表姑表弟'],
        'f,f,xs,d,s&l,w':['堂姑表表弟媳'],
        'f,f,xs,d,s,s':['堂姑表表弟媳','姑表姑表侄男'],
        'f,f,xs,d,s,s,w':['堂姑表表侄妇','姑表姑表侄妇'],
        'f,f,xs,d,s,d':['堂姑表表侄女','姑表姑表侄女'],
        'f,f,xs,d,s,d,h':['堂姑表表侄婿','姑表姑表侄婿'],
        'f,f,xs,d,d&o':['堂姑表表姐','姑表姑表姐'],
        'f,f,xs,d,d&o,h':['堂姑表表姐夫','姑表姑表姐夫'],
        'f,f,xs,d,d&l':['堂姑表表妹','姑表姑表妹'],
        'f,f,xs,d,d&l,h':['堂姑表表妹夫','姑表姑表妹夫'],
        'f,f,xs,d,d,s':['堂姑表表甥男','姑表姑表甥男'],
        'f,f,xs,d,d,s,w':['堂姑表表甥妇','姑表姑表甥妇'],
        'f,f,xs,d,d,d':['堂姑表表甥女','姑表姑表甥女'],
        'f,f,xs,d,d,d,h':['堂姑表表甥婿','姑表姑表甥婿'],
        // 奶奶
        'f,m':['奶奶','祖母','阿嫲','阿嬷','嫲嫲','吖麻'],
        'f,m,f':['曾外祖父','太外公','太姥爷'],
        'f,m,f,f':['曾外曾祖父','祖太爷','祖太爷爷','祖太公','高王父'],
        'f,m,f,m':['曾外曾祖母','祖太太','祖太奶奶','祖太婆','高王母'],
        // 从父*
        'f,m,f,ob':['伯曾外祖父','伯太姥爷','伯太奶爷'],
        'f,m,f,ob,w':['伯曾外祖母','伯太姥姥','伯太奶奶'],
        'f,m,f,lb':['叔曾外祖父','叔太姥爷','叔太奶爷'],
        'f,m,f,lb,w':['叔曾外祖母','叔太姥姥','叔太奶奶'],
        // 从父舅表
        'f,m,f,xb,s':['堂舅祖父','从父舅祖父'],
        'f,m,f,xb,s,w':['堂舅祖母','从父舅祖母'],
        'f,m,f,xb,s,s&o':['堂舅表伯父','从父舅表伯父'],
        'f,m,f,xb,s,s&o,w':['堂舅表伯母','从父舅表伯母'],
        'f,m,f,xb,s,s&l':['堂舅表叔父','从父舅表叔父'],
        'f,m,f,xb,s,s&l,w':['堂舅表叔母','从父舅表叔母'],
        'f,m,f,xb,s,d':['堂舅表姑母','从父舅表姑母'],
        'f,m,f,xb,s,d,h':['堂舅表姑父','从父舅表姑父'],
        // 从父姨表
        'f,m,f,xb,d':['堂姨祖母','从父姨祖母'],
        'f,m,f,xb,d,h':['堂姨祖父','从父姨祖父'],
        'f,m,f,xb,d,s&o':['堂姨表伯父','从父姨表伯父'],
        'f,m,f,xb,d,s&o,w':['堂姨表伯母','从父姨表伯母'],
        'f,m,f,xb,d,s&l':['堂姨表叔父','从父姨表叔父'],
        'f,m,f,xb,d,s&l,w':['堂姨表叔母','从父姨表叔母'],
        'f,m,f,xb,d,d':['堂姨表姑母','从父姨表姑母'],
        'f,m,f,xb,d,d,h':['堂姨表姑父','从父姨表姑父'],
        // 姑表*
        'f,m,f,xs':['姑曾外祖母','姑太姥姥','姑太奶奶'],
        'f,m,f,xs,h':['姑曾外祖父','姑太姥爷','姑太奶爷','姑太爷爷'],
        // 姑表舅表
        'f,m,f,xs,s':['姑表舅祖父'],
        'f,m,f,xs,s,w':['姑表舅祖母'],
        'f,m,f,xs,s,s&o':['姑表舅表伯父'],
        'f,m,f,xs,s,s&o,w':['姑表舅表伯母'],
        'f,m,f,xs,s,s&l':['姑表舅表叔父'],
        'f,m,f,xs,s,s&l,w':['姑表舅表叔母'],
        'f,m,f,xs,s,d':['姑表舅表姑母'],
        'f,m,f,xs,s,d,h':['姑表舅表姑父'],
        // 姑表姨表
        'f,m,f,xs,d':['姑表姨祖母'],
        'f,m,f,xs,d,h':['姑表姨祖父'],
        'f,m,f,xs,d,s&o':['姑表姨表伯父'],
        'f,m,f,xs,d,s&o,w':['姑表姨表伯母'],
        'f,m,f,xs,d,s&l':['姑表姨表叔父'],
        'f,m,f,xs,d,s&l,w':['姑表姨表叔母'],
        'f,m,f,xs,d,d':['姑表姨表姑母'],
        'f,m,f,xs,d,d,h':['姑表姨表姑父'],
        'f,m,m':['曾外祖母','太外婆','太姥姥'],
        'f,m,m,f':['曾外曾外祖父','祖太姥爷','祖太公','高王父'],
        'f,m,m,m':['曾外曾外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
        // 舅表*
        'f,m,m,xb':['舅曾外祖父','舅太姥爷','舅太奶爷'],
        'f,m,m,xb,w':['舅曾外祖母','舅太姥姥','舅太奶奶'],
        // 舅表舅表
        'f,m,m,xb,s':['舅表舅祖父'],
        'f,m,m,xb,s,w':['舅表舅祖母'],
        'f,m,m,xb,s,s&o':['舅表舅表伯父'],
        'f,m,m,xb,s,s&o,w':['舅表舅表伯母'],
        'f,m,m,xb,s,s&l':['舅表舅表叔父'],
        'f,m,m,xb,s,s&l,w':['舅表舅表叔母'],
        'f,m,m,xb,s,d':['舅表舅表姑母'],
        'f,m,m,xb,s,d,h':['舅表舅表姑父'],
        // 舅表姨表
        'f,m,m,xb,d':['舅表姨祖母'],
        'f,m,m,xb,d,h':['舅表姨祖父'],
        'f,m,m,xb,d,s&o':['舅表姨表伯父'],
        'f,m,m,xb,d,s&o,w':['舅表姨表伯母'],
        'f,m,m,xb,d,s&l':['舅表姨表叔父'],
        'f,m,m,xb,d,s&l,w':['舅表姨表叔母'],
        'f,m,m,xb,d,d':['舅表姨表姑母'],
        'f,m,m,xb,d,d,h':['舅表姨表姑父'],
        // 从母*
        'f,m,m,xs':['姨曾外祖母','姨太姥姥','姨太奶奶'],
        'f,m,m,xs,h':['姨曾外祖父','姨太姥爷','姨太奶爷'],
        // 从母舅表
        'f,m,m,xs,s':['从母舅祖父'],
        'f,m,m,xs,s,w':['从母舅祖母'],
        'f,m,m,xs,s,s&o':['从母舅表伯父'],
        'f,m,m,xs,s,s&o,w':['从母舅表伯母'],
        'f,m,m,xs,s,s&l':['从母舅表叔父'],
        'f,m,m,xs,s,s&l,w':['从母舅表叔父'],
        'f,m,m,xs,s,d':['从母舅表姑母'],
        'f,m,m,xs,s,d,h':['从母舅表姑父'],
        // 从母姨表
        'f,m,m,xs,d':['从母姨祖母'],
        'f,m,m,xs,d,h':['从母姨祖父'],
        'f,m,m,xs,d,s&o':['再从母伯父'],
        'f,m,m,xs,d,s&o,w':['再从母伯母'],
        'f,m,m,xs,d,s&l':['再从母叔父'],
        'f,m,m,xs,d,s&l,w':['再从母叔母'],
        'f,m,m,xs,d,d':['再从母姑母'],
        'f,m,m,xs,d,d,h':['再从母姑父'],
        // 舅表*
        'f,m,xb':['舅公','舅祖父','舅老爷','舅爷爷','舅爷','舅祖','舅奶爷','太舅父','x舅老爷','x舅公'],
        'f,m,xb,w':['舅婆','舅祖母','舅奶奶','舅奶','妗婆','妗奶','太舅母'],
        // 舅表叔表
        'f,m,xb,s&o':['舅表伯父','表伯父','表伯'],
        'f,m,xb,s&o,w':['舅表伯母','表伯母'],
        'f,m,xb,s&l':['舅表叔父','表叔父','表叔爸','表叔'],
        'f,m,xb,s&l,w':['舅表叔母','表叔母','表叔妈','表婶'],
        'f,m,xb,s,s&o':['舅表叔表哥'],
        'f,m,xb,s,s&o,w':['舅表叔表嫂'],
        'f,m,xb,s,s&l':['舅表叔表弟'],
        'f,m,xb,s,s&l,w':['舅表叔表弟媳'],
        'f,m,xb,s,s,s':['舅表叔表侄男'],
        'f,m,xb,s,s,s,w':['舅表叔表侄妇'],
        'f,m,xb,s,s,d':['舅表叔表侄女'],
        'f,m,xb,s,s,d,h':['舅表叔表侄婿'],
        'f,m,xb,s,d&o':['舅表叔表姐'],
        'f,m,xb,s,d&o,h':['舅表叔表姐夫'],
        'f,m,xb,s,d&l':['舅表叔表妹'],
        'f,m,xb,s,d&l,h':['舅表叔表妹夫'],
        'f,m,xb,s,d,s':['舅表叔表甥男'],
        'f,m,xb,s,d,s,w':['舅表叔表甥妇'],
        'f,m,xb,s,d,d':['舅表叔表甥女'],
        'f,m,xb,s,d,d,h':['舅表叔表甥婿'],
        // 舅表姑表
        'f,m,xb,d':['舅表姑母','表姑妈','表姑母','表姑姑','表姑'],
        'f,m,xb,d,h':['舅表姑父','表姑爸','表姑父','表姑丈'],
        'f,m,xb,d,s&o':['舅表姑表哥'],
        'f,m,xb,d,s&o,w':['舅表姑表嫂'],
        'f,m,xb,d,s&l':['舅表姑表弟'],
        'f,m,xb,d,s&l,w':['舅表姑表弟媳'],
        'f,m,xb,d,s,s':['舅表姑表侄男'],
        'f,m,xb,d,s,s,w':['舅表姑表侄妇'],
        'f,m,xb,d,s,d':['舅表姑表侄女'],
        'f,m,xb,d,s,d,h':['舅表姑表侄婿'],
        'f,m,xb,d,d&o':['舅表姑表姐'],
        'f,m,xb,d,d&o,h':['舅表姑表姐夫'],
        'f,m,xb,d,d&l':['舅表姑表妹'],
        'f,m,xb,d,d&l,h':['舅表姑表妹夫'],
        'f,m,xb,d,d,s':['舅表姑表甥男'],
        'f,m,xb,d,d,s,w':['舅表姑表甥妇'],
        'f,m,xb,d,d,d':['舅表姑表甥女'],
        'f,m,xb,d,d,d,h':['舅表姑表甥婿'],
        // 从母*
        'f,m,xs':['姨奶奶','祖姨母','姨祖母','姨婆','姨奶','x姨奶'],
        'f,m,xs,h':['姨爷爷','祖姨父','姨祖父','姨公','姨丈公','姨爷','姨老爷','姨奶爷'],
        // 从母叔表
        'f,m,xs,s&o':['姨伯父','姨伯','从母伯父'],
        'f,m,xs,s&o,w':['姨伯母','从母伯母'],
        'f,m,xs,s&l':['姨叔父','姨叔','从母叔父'],
        'f,m,xs,s&l,w':['姨叔母','从母叔母'],
        'f,m,xs,s,s&o':['从母叔表哥'],
        'f,m,xs,s,s&o,w':['从母叔表嫂'],
        'f,m,xs,s,s&l':['从母叔表弟'],
        'f,m,xs,s,s&l,w':['从母叔表弟媳'],
        'f,m,xs,s,s,s':['从母叔表侄男'],
        'f,m,xs,s,s,s,w':['从母叔表侄妇'],
        'f,m,xs,s,s,d':['从母叔表侄女'],
        'f,m,xs,s,s,d,h':['从母叔表侄婿'],
        'f,m,xs,s,d&o':['从母叔表姐'],
        'f,m,xs,s,d&o,h':['从母叔表姐夫'],
        'f,m,xs,s,d&l':['从母叔表妹'],
        'f,m,xs,s,d&l,h':['从母叔表妹夫'],
        'f,m,xs,s,d,s':['从母叔表甥男'],
        'f,m,xs,s,d,s,w':['从母叔表甥妇'],
        'f,m,xs,s,d,d':['从母叔表甥女'],
        'f,m,xs,s,d,d,h':['从母叔表甥婿'],
        // 从母姑表
        'f,m,xs,d':['姨姑母','姨姑','从母姑母'],
        'f,m,xs,d,h':['姨姑父','从母姑父','从母姑丈'],
        'f,m,xs,d,s&o':['从母姑表哥'],
        'f,m,xs,d,s&o,w':['从母姑表嫂'],
        'f,m,xs,d,s&l':['从母姑表弟'],
        'f,m,xs,d,s&l,w':['从母姑表弟媳'],
        'f,m,xs,d,s,s':['从母姑表侄男'],
        'f,m,xs,d,s,s,w':['从母姑表侄妇'],
        'f,m,xs,d,s,d':['从母姑表侄女'],
        'f,m,xs,d,s,d,h':['从母姑表侄婿'],
        'f,m,xs,d,d&o':['从母姑表姐'],
        'f,m,xs,d,d&o,h':['从母姑表姐夫'],
        'f,m,xs,d,d&l':['从母姑表妹'],
        'f,m,xs,d,d&l,h':['从母姑表妹夫'],
        'f,m,xs,d,d,s':['从母姑表甥男'],
        'f,m,xs,d,d,s,w':['从母姑表甥妇'],
        'f,m,xs,d,d,d':['从母姑表甥女'],
        'f,m,xs,d,d,d,h':['从母姑表甥婿'],
        // 从父
        'f,ob':['伯父','伯伯','阿伯','大伯','大爹','大爸','x伯'],
        'f,ob,w':['伯母','伯妈','伯娘','姆姆','大娘','大妈','x妈'],
        'f,lb':['叔叔','叔父','叔爸','叔爹','阿叔','仲父','小叔','小爹','小爸','幺爸','叔','x叔'],
        'f,lb,w':['婶婶','婶母','婶娘','婶爹','阿婶','婶妈','小婶','小婶娘','婶子','婶儿','家婶','叔母','叔妈','叔娘','季母','小娘','小妈','幺婶','婶','x婶'],
        'f,xb,w,f':['叔眷外祖父','叔眷王父','叔眷毑父','叔眷姥爷','眷姥爷'],
        'f,xb,w,m':['叔眷外祖女','叔眷王母','叔眷毑母','叔眷姥姥','眷姥姥'],
        'f,xb,w,xb':['叔眷舅父','眷舅父'],
        'f,xb,w,xb,w':['叔眷舅母','眷舅母'],
        'f,xb,w,xb,s&o':['叔眷舅表哥'],
        'f,xb,w,xb,s&o,w':['叔眷舅表嫂'],
        'f,xb,w,xb,s&l':['叔眷舅表弟'],
        'f,xb,w,xb,s&l,w':['叔眷舅表弟媳'],
        'f,xb,w,xb,s,s':['叔眷侄男'],
        'f,xb,w,xb,s,s,w':['叔眷侄妇'],
        'f,xb,w,xb,s,d':['叔眷侄女'],
        'f,xb,w,xb,s,d,h':['叔眷侄婿'],
        'f,xb,w,xb,d&o':['叔眷舅表姐'],
        'f,xb,w,xb,d&o,h':['叔眷舅表姐夫'],
        'f,xb,w,xb,d&l':['叔眷舅表妹'],
        'f,xb,w,xb,d&l,h':['叔眷舅表妹夫'],
        'f,xb,w,xb,d,s':['叔眷甥男'],
        'f,xb,w,xb,d,s,w':['叔眷甥妇'],
        'f,xb,w,xb,d,d':['叔眷甥女'],
        'f,xb,w,xb,d,d,h':['叔眷甥婿'],
        'f,xb,w,xs':['叔眷姨母','眷姨母'],
        'f,xb,w,xs,h':['叔眷姨父','眷姨父'],
        'f,xb,w,xs,s&o':['叔眷姨表哥'],
        'f,xb,w,xs,s&o,w':['叔眷姨表嫂'],
        'f,xb,w,xs,s&l':['叔眷姨表弟'],
        'f,xb,w,xs,s&l,w':['叔眷姨表弟媳'],
        'f,xb,w,xs,d&o':['叔眷姨表姐'],
        'f,xb,w,xs,d&o,h':['叔眷姨表姐夫'],
        'f,xb,w,xs,d&l':['叔眷姨表妹'],
        'f,xb,w,xs,d&l,h':['叔眷姨表妹夫'],
        'f,xb,s&o':['堂哥','堂兄','堂阿哥','从父兄','叔伯兄','从兄'],
        'f,xb,s&o,w':['堂嫂','从父兄妇','叔伯兄妇'],
        'f,xb,s&l':['堂弟','堂阿弟','从父弟','叔伯弟','从弟'],
        'f,xb,s&l,w':['堂弟媳','堂弟妹','从父弟妇','叔伯弟妇'],
        'f,xb,s,w,f':['从父兄弟眷父'],
        'f,xb,s,w,m':['从父兄弟眷母'],
        'f,xb,s,w,xb&o':['从父兄弟眷兄'],
        'f,xb,s,w,xb&o,w':['从父兄弟眷兄妇'],
        'f,xb,s,w,xb&l':['从父兄弟眷弟'],
        'f,xb,s,w,xb&l,w':['从父兄弟眷弟妇'],
        'f,xb,s,w,xs&o':['从父兄弟眷姊'],
        'f,xb,s,w,xs&o,h':['从父兄弟眷姊婿'],
        'f,xb,s,w,xs&l':['从父兄弟眷妹'],
        'f,xb,s,w,xs&l,h':['从父兄弟眷妹婿'],
        'f,xb,s,s':['堂侄','堂侄子','堂侄男','从父侄男','叔伯侄男','叔伯侄'],
        'f,xb,s,s,w':['堂侄媳妇','堂侄妇','从父侄妇','叔伯侄妇'],
        'f,xb,s,s,s':['堂侄孙男','从父侄孙男','堂侄孙','从父侄孙'],
        'f,xb,s,s,s,w':['堂侄孙妇','从父侄孙妇'],
        'f,xb,s,s,d':['堂侄孙女','从父侄孙女','堂侄孙','从父侄孙'],
        'f,xb,s,s,d,h':['堂侄孙婿','从父侄孙婿'],
        'f,xb,s,d':['堂侄女','从父侄女','叔伯侄女','堂侄','叔伯侄'],
        'f,xb,s,d,h':['堂侄女婿','堂侄婿','从父侄婿','叔伯侄婿'],
        'f,xb,s,d,s':['堂侄外孙男','从父侄外孙男','堂侄外孙','从父侄外孙'],
        'f,xb,s,d,s,w':['堂侄外孙妇','从父侄外孙妇'],
        'f,xb,s,d,d':['堂侄外孙女','从父侄外孙女','堂侄外孙','从父侄外孙'],
        'f,xb,s,d,d,h':['堂侄外孙婿','从父侄外孙婿'],
        'f,xb,d&o':['堂姐','堂阿姐','从父姐','叔伯姐','从姐'],
        'f,xb,d&o,h':['堂姐夫','从父姐夫','从父姐夫','叔伯姐夫'],
        'f,xb,d&l':['堂妹','堂阿妹','从父妹','叔伯妹','从妹'],
        'f,xb,d&l,h':['堂妹夫','从父妹夫','从父妹婿','叔伯妹夫'],
        'f,xb,d,h,f':['从父姊妹姻父'],
        'f,xb,d,h,m':['从父姊妹姻母'],
        'f,xb,d,h,xb&o':['从父姊妹姻兄'],
        'f,xb,d,h,xb&o,w':['从父姊妹姻兄妇'],
        'f,xb,d,h,xb&l':['从父姊妹姻弟'],
        'f,xb,d,h,xb&l,w':['从父姊妹姻弟妇'],
        'f,xb,d,h,xs&o':['从父姊妹姻姊'],
        'f,xb,d,h,xs&o,h':['从父姊妹姻姊婿'],
        'f,xb,d,h,xs&l':['从父姊妹姻妹'],
        'f,xb,d,h,xs&l,h':['从父姊妹姻妹婿'],
        'f,xb,d,s':['堂外甥','堂甥男','从父甥男','叔伯甥','堂甥'],
        'f,xb,d,s,w':['堂甥媳妇','堂甥妇','从父甥妇'],
        'f,xb,d,s,s':['堂甥孙男','从父甥孙男','堂甥孙','从父甥孙'],
        'f,xb,d,s,s,w':['堂甥孙妇','从父甥孙妇'],
        'f,xb,d,s,d':['堂甥孙女','从父甥孙女','堂甥孙','从父甥孙'],
        'f,xb,d,s,d,h':['堂甥孙婿','从父甥孙婿'],
        'f,xb,d,d':['堂外甥女','堂甥女','从父甥女','叔伯甥','堂甥'],
        'f,xb,d,d,h':['堂甥女婿','堂甥婿','从父甥婿'],
        'f,xb,d,d,s':['堂甥外孙男','从父甥外孙男','堂甥外孙','从父甥外孙'],
        'f,xb,d,d,s,w':['堂甥外孙妇','从父甥外孙妇'],
        'f,xb,d,d,d':['堂甥外孙女','从父甥外孙女','堂甥外孙','从父甥外孙'],
        'f,xb,d,d,d,h':['堂甥外孙婿','从父甥外孙婿'],
        // 姑表
        'f,os':['姑母','大姑妈'],
        'f,ls':['姑姐','小姑妈','姑仔'],
        'f,xs':['姑妈','姑姑','姑娘','姑','x姑妈','x姑'],
        'f,xs,h':['姑丈','姑父','姑爸','姑夫','x姑丈','x姑父'],
        'f,xs,h,f':['姑姻祖父','姑姻王父','姑姻爷爷','姻爷爷'],
        'f,xs,h,m':['姑姻祖母','姑姻王父','姑姻奶奶','姻奶奶'],
        'f,xs,h,ob':['姑姻伯父','姻伯父'],
        'f,xs,h,ob,w':['姑姻伯母','姻伯母'],
        'f,xs,h,lb':['姑姻叔父','姻叔父'],
        'f,xs,h,lb,w':['姑姻叔母','姻叔母'],
        'f,xs,h,xb,s&o':['姑姻叔表哥'],
        'f,xs,h,xb,s&o,w':['姑姻叔表嫂'],
        'f,xs,h,xb,s&l':['姑姻叔表弟'],
        'f,xs,h,xb,s&l,w':['姑姻叔表弟媳'],
        'f,xs,h,xb,s,s':['姑姻侄男'],
        'f,xs,h,xb,s,s,w':['姑姻侄妇'],
        'f,xs,h,xb,s,d':['姑姻侄女'],
        'f,xs,h,xb,s,d,h':['姑姻侄婿'],
        'f,xs,h,xb,d&o':['姑姻叔表姐'],
        'f,xs,h,xb,d&o,h':['姑姻叔表姐夫'],
        'f,xs,h,xb,d&l':['姑姻叔表妹'],
        'f,xs,h,xb,d&l,h':['姑姻叔表妹夫'],
        'f,xs,h,xb,d,s':['姑姻甥男'],
        'f,xs,h,xb,d,s,w':['姑姻甥妇'],
        'f,xs,h,xb,d,d':['姑姻甥女'],
        'f,xs,h,xb,d,d,h':['姑姻甥婿'],
        'f,xs,h,xs':['姑姻姑母','姻姑母'],
        'f,xs,h,xs,h':['姑姻姑父','姻姑父'],
        'f,xs,h,xs,s&o':['姑姻姑表哥'],
        'f,xs,h,xs,s&o,w':['姑姻姑表嫂'],
        'f,xs,h,xs,s&l':['姑姻姑表弟'],
        'f,xs,h,xs,s&l,w':['姑姻姑表弟媳'],
        'f,xs,h,xs,d&o':['姑姻姑表姐'],
        'f,xs,h,xs,d&o,h':['姑姻姑表姐夫'],
        'f,xs,h,xs,d&l':['姑姻姑表妹'],
        'f,xs,h,xs,d&l,h':['姑姻姑表妹夫'],
        'f,xs,s&o':['姑表哥','表哥','表兄'],
        'f,xs,s&o,w':['姑表嫂','姑表兄妇','表嫂'],
        'f,xs,s&l':['姑表弟','表弟'],
        'f,xs,s&l,w':['姑表弟媳','表弟媳','表弟妹'],
        'f,xs,s,s':['姑表侄男','表侄男','表侄'],
        'f,xs,s,s,w':['姑表侄妇','表侄妇'],
        'f,xs,s,s,s':['姑表侄孙男','表侄孙男','姑表侄孙','表侄孙'],
        'f,xs,s,s,s,w':['姑表侄孙妇','表侄孙妇'],
        'f,xs,s,s,d':['姑表侄孙女','表侄孙女','姑表侄孙','表侄孙'],
        'f,xs,s,s,d,h':['姑表侄孙婿','表侄孙婿'],
        'f,xs,s,d':['姑表侄女','表侄女','表侄'],
        'f,xs,s,d,h':['姑表侄婿','表侄婿'],
        'f,xs,s,d,s':['姑表侄外孙男','表侄外孙男','姑表侄外孙','表侄外孙'],
        'f,xs,s,d,s,w':['姑表侄外孙妇','表侄外孙妇'],
        'f,xs,s,d,d':['姑表侄外孙女','表侄外孙女','姑表侄外孙','表侄外孙'],
        'f,xs,s,d,d,h':['姑表侄外孙婿','表侄外孙婿'],
        'f,xs,d&o':['姑表姐','表姐'],
        'f,xs,d&o,h':['姑表姐夫','表姐夫','表姐丈'],
        'f,xs,d&l':['姑表妹','表妹'],
        'f,xs,d&l,h':['姑表妹夫','姑表妹婿','表妹夫'],
        'f,xs,d,s':['姑表甥男','表甥男','表外甥'],
        'f,xs,d,s,w':['姑表甥妇','表甥妇'],
        'f,xs,d,s,s':['姑表甥孙男','表甥孙男','姑表甥孙','表甥孙'],
        'f,xs,d,s,s,w':['姑表甥孙妇','表甥孙妇'],
        'f,xs,d,s,d':['姑表甥孙女','表甥孙女','姑表甥孙','表甥孙'],
        'f,xs,d,s,d,h':['姑表甥孙婿','表甥孙婿'],
        'f,xs,d,d':['姑表甥女','表甥女','表外甥'],
        'f,xs,d,d,h':['姑表甥婿','表甥婿'],
        'f,xs,d,d,s':['姑表甥外孙男','表甥外孙男','姑表甥外孙','表甥外孙'],
        'f,xs,d,d,s,w':['姑表甥外孙妇','表甥外孙妇'],
        'f,xs,d,d,d':['姑表甥外孙女','表甥外孙女','姑表甥外孙','表甥外孙'],
        'f,xs,d,d,d,h':['姑表甥外孙婿','表甥外孙婿'],
        // 外家
        'm':['妈妈','母亲','阿妈','老母','老妈','老妈子','妈','母','娘','娘亲','妈咪'],
        // 外公
        'm,f':['外公','外祖父','外王父','姥爷','阿公','客公','外爷','毑父'],
        'm,f,f':['外曾祖父','曾外祖父','外太祖父','外曾王父','外太公','外太爷爷','太外祖父'],
        'm,f,f,f':['外高祖父','高外祖父','祖太爷','祖太爷爷','祖太公','高王父'],
        'm,f,f,m':['外高祖母','高外祖母','祖太太','祖太奶奶','祖太婆','高王母'],
        // 从父*
        'm,f,f,ob':['伯外曾祖父','外太伯公','伯太姥爷','伯太奶爷','伯太爷爷'],
        'm,f,f,ob,w':['伯外曾祖母','外太伯母','伯太姥姥','伯太奶奶'],
        'm,f,f,lb':['叔外曾祖父','外太叔公','叔太姥爷','叔太奶爷','叔太爷爷'],
        'm,f,f,lb,w':['叔外曾祖母','外太叔母','叔太姥姥','叔太奶奶'],
        // 再从父
        'm,f,f,xb,s':['堂外祖父','从父外祖父','从父姥爷'],
        'm,f,f,xb,s,w':['堂外祖母','从父外祖母','从父姥姥'],
        'm,f,f,xb,s&o':['堂伯外祖父','从父伯外祖父','从父伯姥爷'],
        'm,f,f,xb,s&o,w':['堂伯外祖母','从父伯外祖母','从父伯姥姥'],
        'm,f,f,xb,s&l':['堂叔外祖父','从父叔外祖父','从父叔姥爷'],
        'm,f,f,xb,s&l,w':['堂叔外祖母','从父叔外祖母','从父叔姥姥'],
        'm,f,f,xb,s,s':['再从父舅父'],
        'm,f,f,xb,s,s,w':['再从父舅母'],
        'm,f,f,xb,s,d':['再从父姨母'],
        'm,f,f,xb,s,d,h':['再从父姨父'],
        // 从父姑表
        'm,f,f,xb,d':['堂姑外祖母','从父姑外祖母'],
        'm,f,f,xb,d,h':['堂姑外祖父','从父姑外祖父'],
        'm,f,f,xb,d,s':['堂姑表舅父','从父姑表舅父'],
        'm,f,f,xb,d,s,w':['堂姑表舅母','从父姑表舅母'],
        'm,f,f,xb,d,d':['堂姑表姨母','从父姑表姨母'],
        'm,f,f,xb,d,d,h':['堂姑表姨父','从父姑表姨父'],
        // 姑表*
        'm,f,f,xs':['姑外曾祖母','外太姑婆','姑太姥姥','姑太奶奶'],
        'm,f,f,xs,h':['姑外曾祖父','外太姑丈公','姑太姥爷','姑太奶爷','姑太爷爷'],
        // 姑表叔表
        'm,f,f,xs,s&o':['姑表伯外祖父',],
        'm,f,f,xs,s&o,w':['姑表伯外祖母'],
        'm,f,f,xs,s&l':['姑表叔外祖父'],
        'm,f,f,xs,s&l,w':['姑表叔外祖母'],
        'm,f,f,xs,s,s':['姑表叔表舅父'],
        'm,f,f,xs,s,s,w':['姑表叔表舅母'],
        'm,f,f,xs,s,d':['姑表叔表姨母'],
        'm,f,f,xs,s,d,h':['姑表叔表姨父'],
        // 姑表姑表
        'm,f,f,xs,d':['姑表姑外祖母'],
        'm,f,f,xs,d,h':['姑表姑外祖父'],
        'm,f,f,xs,d,s':['姑表姑表舅父'],
        'm,f,f,xs,d,s,w':['姑表姑表舅母'],
        'm,f,f,xs,d,d':['姑表姑表姨母'],
        'm,f,f,xs,d,d,h':['姑表姑表姨父'],
        'm,f,m':['外曾祖母','外太祖母','外曾王母','太外祖母','外太奶奶','外太婆'],
        'm,f,m,f':['外高外祖父','祖太姥爷','祖太公','高王父'],
        'm,f,m,m':['外高外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
        // 舅表*
        'm,f,m,xb':['舅外曾祖父','外曾舅祖父','外太舅公','舅太姥爷','舅太奶爷'],
        'm,f,m,xb,w':['舅外曾祖母','外曾舅祖母','外太舅母','舅太姥姥','舅太奶奶','外太舅婆'],
        // 舅表叔表
        'm,f,m,xb,s&o':['舅表伯外祖父'],
        'm,f,m,xb,s&o,w':['舅表伯外祖母'],
        'm,f,m,xb,s&l':['舅表叔外祖父'],
        'm,f,m,xb,s&l,w':['舅表叔外祖母'],
        'm,f,m,xb,s,s':['舅表叔表舅父'],
        'm,f,m,xb,s,s,w':['舅表叔表舅母'],
        'm,f,m,xb,s,d':['舅表叔表姨母'],
        'm,f,m,xb,s,d,h':['舅表叔表姨父'],
        // 舅表姑表
        'm,f,m,xb,d':['舅表姑外祖母'],
        'm,f,m,xb,d,h':['舅表姑外祖父'],
        'm,f,m,xb,d,s':['舅表姑表舅父'],
        'm,f,m,xb,d,s,w':['舅表姑表舅母'],
        'm,f,m,xb,d,d':['舅表姑表姨母'],
        'm,f,m,xb,d,d,h':['舅表姑表姨父'],
        // 从母*
        'm,f,m,xs':['姨外曾祖母','外曾姨祖母','外太姨婆','姨太姥姥','姨太奶奶'],
        'm,f,m,xs,h':['姨外曾祖父','外曾姨祖父','外太姑姨公','姨太姥爷','姨太奶爷','姨太爷爷'],
        // 从母叔表
        'm,f,m,xs,s&o':['从母伯外祖父'],
        'm,f,m,xs,s&o,w':['从母伯外祖母'],
        'm,f,m,xs,s&l':['从母叔外祖父'],
        'm,f,m,xs,s&l,w':['从母叔外祖父'],
        'm,f,m,xs,s,s':['从母叔表舅父'],
        'm,f,m,xs,s,s,w':['从母叔表舅母'],
        'm,f,m,xs,s,d':['从母叔表姨母'],
        'm,f,m,xs,s,d,h':['从母叔表姨父'],
        // 从母姑表
        'm,f,m,xs,d':['从母姑外祖母'],
        'm,f,m,xs,d,h':['从母姑外祖父'],
        'm,f,m,xs,d,s':['从母姑表舅父'],
        'm,f,m,xs,d,s,w':['从母姑表舅母'],
        'm,f,m,xs,d,d':['从母姑表姨母'],
        'm,f,m,xs,d,d,h':['从母姑表姨父'],
        // 从父*
        'm,f,ob':['外伯公','伯外祖父','外伯祖父','伯姥爷','外伯祖','大外公','大姥爷','x外公','x姥爷'],
        'm,f,ob,w':['外伯婆','伯外祖母','外伯祖母','伯姥姥','大姥姥','外姆婆','小外公','小姥爷','x外公','x姥爷'],
        'm,f,lb':['外叔公','叔外祖父','外叔祖父','叔姥爷','外叔祖','叔外祖'],
        'm,f,lb,w':['外叔婆','叔外祖母','外叔祖母','叔姥姥','小姥姥','外姆婆'],
        // 从父舅表
        'm,f,xb,s':['堂舅','堂舅爸','堂舅父','堂舅舅','从父舅父','叔伯舅父','叔伯舅'],
        'm,f,xb,s,w':['堂舅妈','堂舅母','从父舅母','叔伯舅母'],
        'm,f,xb,s,s&o':['堂舅表哥','从父舅表哥'],
        'm,f,xb,s,s&o,w':['堂舅表嫂','从父舅表嫂'],
        'm,f,xb,s,s&l':['堂舅表弟','从父舅表弟'],
        'm,f,xb,s,s&l,w':['堂舅表弟媳','从父舅表弟媳'],
        'm,f,xb,s,s,s':['堂舅表侄男','从父舅表侄男'],
        'm,f,xb,s,s,s,w':['堂舅表侄妇','从父舅表侄妇'],
        'm,f,xb,s,s,d':['堂舅表侄女','从父舅表侄女'],
        'm,f,xb,s,s,d,h':['堂舅表侄婿','从父舅表侄婿'],
        'm,f,xb,s,d&o':['堂舅表姐','从父舅表姐'],
        'm,f,xb,s,d&o,h':['堂舅表姐夫','从父舅表姐夫'],
        'm,f,xb,s,d&l':['堂舅表妹','从父舅表妹'],
        'm,f,xb,s,d&l,h':['堂舅表妹夫','从父舅表妹夫'],
        'm,f,xb,s,d,s':['堂舅表甥男','从父舅表甥男'],
        'm,f,xb,s,d,s,w':['堂舅表甥妇','从父舅表甥妇'],
        'm,f,xb,s,d,d':['堂舅表甥女','从父舅表甥女'],
        'm,f,xb,s,d,d,h':['堂舅表甥婿','从父舅表甥婿'],
        // 从父姨表
        'm,f,xb,d':['堂姨','堂姨妈','堂姨母','从父姨母','叔伯姨母','叔伯姨'],
        'm,f,xb,d,h':['堂姨丈','堂姨爸','堂姨父','从父姨父','叔伯姨父'],
        'm,f,xb,d,s&o':['堂姨表哥','从父姨表哥'],
        'm,f,xb,d,s&o,w':['堂姨表嫂','从父姨表嫂'],
        'm,f,xb,d,s&l':['堂姨表弟','从父姨表弟'],
        'm,f,xb,d,s&l,w':['堂姨表弟媳','从父姨表弟媳'],
        'm,f,xb,d,s,s':['堂姨表侄男','从父姨表侄男'],
        'm,f,xb,d,s,s,w':['堂姨表侄妇','从父姨表侄妇'],
        'm,f,xb,d,s,d':['堂姨表侄女','从父姨表侄女'],
        'm,f,xb,d,s,d,h':['堂姨表侄婿','从父姨表侄婿'],
        'm,f,xb,d,d&o':['堂姨表姐','从父姨表姐'],
        'm,f,xb,d,d&o,h':['堂姨表姐夫','从父姨表姐夫'],
        'm,f,xb,d,d&l':['堂姨表妹','从父姨表妹'],
        'm,f,xb,d,d&l,h':['堂姨表妹夫','从父姨表妹夫'],
        'm,f,xb,d,d,s':['堂舅表甥男','从父舅表甥男'],
        'm,f,xb,d,d,s,w':['堂舅表甥妇','从父舅表甥妇'],
        'm,f,xb,d,d,d':['堂舅表甥女','从父舅表甥女'],
        'm,f,xb,d,d,d,h':['堂舅表甥婿','从父舅表甥婿'],
        // 姑表*
        'm,f,xs':['外姑婆','姑姥姥','姑外祖母','外姑祖母','外太姑母','外姑母'],
        'm,f,xs,h':['外姑公','姑姥爷','姑外祖父','外姑祖父','外太姑父','外姑丈'],
        // 姑表舅表
        'm,f,xs,s':['姑表舅父','姑表舅爸','表舅父','表舅爸','表舅','表舅舅','姑表舅舅'],
        'm,f,xs,s,w':['姑表舅母','姑表舅妈','表舅母','表舅妈'],
        'm,f,xs,s,s&o':['姑表舅表哥'],
        'm,f,xs,s,s&o,w':['姑表舅表嫂'],
        'm,f,xs,s,s&l':['姑表舅表弟'],
        'm,f,xs,s,s&l,w':['姑表舅表弟媳'],
        'm,f,xs,s,s,s':['姑表舅表侄男'],
        'm,f,xs,s,s,s,w':['姑表舅表侄妇'],
        'm,f,xs,s,s,d':['姑表舅表侄女'],
        'm,f,xs,s,s,d,h':['姑表舅表侄婿'],
        'm,f,xs,s,d&o':['姑表舅表姐'],
        'm,f,xs,s,d&o,h':['姑表舅表姐夫'],
        'm,f,xs,s,d&l':['姑表舅表妹'],
        'm,f,xs,s,d&l,h':['姑表舅表妹夫'],
        'm,f,xs,s,d,s':['姑表舅表甥男'],
        'm,f,xs,s,d,s,w':['姑表舅表甥妇'],
        'm,f,xs,s,d,d':['姑表舅表甥女'],
        'm,f,xs,s,d,d,h':['姑表舅表甥婿'],
        // 姑表姨表
        'm,f,xs,d':['姑表姨母','姑表姨妈','表姨母','表姨妈','表姨','表阿姨','姑表姨姨'],
        'm,f,xs,d,h':['姑表姨父','姑表姨父','表姨丈','表姨父'],
        'm,f,xs,d,s&o':['姑表姨表哥'],
        'm,f,xs,d,s&o,w':['姑表姨表嫂'],
        'm,f,xs,d,s&l':['姑表姨表弟'],
        'm,f,xs,d,s&l,w':['姑表姨表弟媳'],
        'm,f,xs,d,s,s':['姑表姨表侄男'],
        'm,f,xs,d,s,s,w':['姑表姨表侄妇'],
        'm,f,xs,d,s,d':['姑表姨表侄女'],
        'm,f,xs,d,s,d,h':['姑表姨表侄婿'],
        'm,f,xs,d,d&o':['姑表姨表姐'],
        'm,f,xs,d,d&o,h':['姑表姨表姐夫'],
        'm,f,xs,d,d&l':['姑表姨表妹'],
        'm,f,xs,d,d&l,h':['姑表姨表妹夫'],
        'm,f,xs,d,d,s':['姑表姨表甥男'],
        'm,f,xs,d,d,s,w':['姑表姨表甥妇'],
        'm,f,xs,d,d,d':['姑表姨表甥女'],
        'm,f,xs,d,d,d,h':['姑表姨表甥婿'],
        // 外婆
        'm,m':['外婆','外祖母','外王母','阿婆','姥姥','客婆','毑母'],
        'm,m,f':['外曾外祖父','外太外公','外太姥爷'],
        'm,m,f,f':['外曾外曾祖父','祖太爷','祖太爷爷','祖太公','高王父'],
        'm,m,f,m':['外曾外曾祖母','祖太太','祖太奶奶','祖太婆','高王母'],
        // 从父*
        'm,m,f,ob':['伯外曾外祖父','伯太姥爷'],
        'm,m,f,ob,w':['伯外曾外祖母','伯太姥姥'],
        'm,m,f,lb':['叔外曾外祖父','叔太姥爷'],
        'm,m,f,lb,w':['叔外曾外祖母','叔太姥姥'],
        // 从父舅表
        'm,m,f,xb,s':['堂舅外祖父','从父舅外祖父'],
        'm,m,f,xb,s,w':['堂舅外祖母','从父舅外祖母'],
        'm,m,f,xb,s,s':['堂舅表舅父','从父舅表舅父'],
        'm,m,f,xb,s,s,w':['堂舅表舅母','从父舅表舅母'],
        'm,m,f,xb,s,d':['堂舅表姨母','从父舅表姨母'],
        'm,m,f,xb,s,d,h':['堂舅表姨父','从父舅表姨父'],
        // 从父姨表
        'm,m,f,xb,d':['堂姨外祖母','从父姨外祖母'],
        'm,m,f,xb,d,h':['堂姨外祖父','从父姨外祖父'],
        'm,m,f,xb,d,s':['堂姨表舅父','从父姨表舅父'],
        'm,m,f,xb,d,s,w':['堂姨表舅母','从父姨表舅母'],
        'm,m,f,xb,d,d':['堂姨表姨母','从父姨表姨母'],
        'm,m,f,xb,d,d,h':['堂姨表姨父','从父姨表姨父'],
        // 姑表*
        'm,m,f,xs':['姑外曾外祖母','姑太姥姥'],
        'm,m,f,xs,h':['姑外曾外祖父','姑太姥爷'],
        // 姑表舅表
        'm,m,f,xs,s':['姑表舅外祖父'],
        'm,m,f,xs,s,w':['姑表舅外祖母'],
        'm,m,f,xs,s,s':['姑表舅表舅父'],
        'm,m,f,xs,s,s,w':['姑表舅表舅母'],
        'm,m,f,xs,s,d':['姑表舅表姨母'],
        'm,m,f,xs,s,d,h':['姑表舅表姨父'],
        // 姑表姨表
        'm,m,f,xs,d':['姑表姨外祖母'],
        'm,m,f,xs,d,h':['姑表姨外祖父'],
        'm,m,f,xs,d,s':['姑表姨表舅父'],
        'm,m,f,xs,d,s,w':['姑表姨表舅母'],
        'm,m,f,xs,d,d':['姑表姨表姨母'],
        'm,m,f,xs,d,d,h':['姑表姨表姨父'],
        'm,m,m':['外曾外祖母','外太外婆','外太姥姥'],
        'm,m,m,f':['外曾外曾外祖父','祖太姥爷','祖太公','高王父'],
        'm,m,m,m':['外曾外曾外祖母','祖太姥姥','祖太姥娘','祖太婆','高王母'],
        // 舅表*
        'm,m,m,xb':['舅外曾外祖父','舅太姥爷'],
        'm,m,m,xb,w':['舅外曾外祖母','舅太姥姥'],
        // 舅表舅表
        'm,m,m,xb,s':['舅表舅外祖父'],
        'm,m,m,xb,s,w':['舅表舅外祖母'],
        'm,m,m,xb,s,s':['舅表舅表舅父'],
        'm,m,m,xb,s,s,w':['舅表舅表舅母'],
        'm,m,m,xb,s,d':['舅表舅表姨母'],
        'm,m,m,xb,s,d,h':['舅表舅表姨父'],
        // 舅表姨表
        'm,m,m,xb,d':['舅表姨外祖母'],
        'm,m,m,xb,d,h':['舅表姨外祖父'],
        'm,m,m,xb,d,s':['舅表姨表舅父'],
        'm,m,m,xb,d,s,w':['舅表姨表舅母'],
        'm,m,m,xb,d,d':['舅表姨表姨母'],
        'm,m,m,xb,d,d,h':['舅表姨表姨父'],
        // 从母*
        'm,m,m,xs':['姨外曾外祖母','姨太姥姥'],
        'm,m,m,xs,h':['姨外曾外祖父','姨太姥爷'],
        // 从母舅表
        'm,m,m,xs,s':['从母舅外祖父'],
        'm,m,m,xs,s,w':['从母舅外祖母'],
        'm,m,m,xs,s,s':['从母舅表舅父'],
        'm,m,m,xs,s,s,w':['从母舅表舅母'],
        'm,m,m,xs,s,d':['从母舅表姨母'],
        'm,m,m,xs,s,d,h':['从母舅表姨父'],
        // 再从母
        'm,m,m,xs,d':['从母姨外祖母','从母姨姥姥'],
        'm,m,m,xs,d,h':['从母姨外祖父','从母姨姥爷'],
        'm,m,m,xs,d,s':['再从母舅父'],
        'm,m,m,xs,d,s,w':['再从母舅母'],
        'm,m,m,xs,d,d':['再从母姨母'],
        'm,m,m,xs,d,d,h':['再从母姨父'],
        'm,m,m,xs,d,d,s&o':['三从母兄'],
        'm,m,m,xs,d,d,s&o,w':['三从母嫂'],
        'm,m,m,xs,d,d,s&l':['三从母弟'],
        'm,m,m,xs,d,d,s&l,w':['三从母弟媳'],
        'm,m,m,xs,d,d,d&o':['三从母姊'],
        'm,m,m,xs,d,d,d&o,h':['三从母姊夫'],
        'm,m,m,xs,d,d,d&l':['三从母妹'],
        'm,m,m,xs,d,d,d&l,h':['三从母妹夫'],
        // 舅表*
        'm,m,xb':['外舅公','外舅祖父','外太舅父','舅外祖父','舅姥爷','舅外公','舅公','x舅姥爷'],
        'm,m,xb,w':['外舅婆','外舅祖母','外太舅母','舅外祖母','舅姥姥','舅婆','外妗婆'],
        // 舅表舅表
        'm,m,xb,s':['舅表舅父','舅表舅爸','表舅父','表舅爸','表舅','表舅舅','舅表舅舅'],
        'm,m,xb,s,w':['舅表舅母','舅表舅妈','表舅母','表舅妈'],
        'm,m,xb,s,s&o':['舅表舅表哥'],
        'm,m,xb,s,s&o,w':['舅表舅表嫂'],
        'm,m,xb,s,s&l':['舅表舅表弟'],
        'm,m,xb,s,s&l,w':['舅表舅表弟媳'],
        'm,m,xb,s,s,s':['舅表舅表侄男'],
        'm,m,xb,s,s,s,w':['舅表舅表侄妇'],
        'm,m,xb,s,s,d':['舅表舅表侄女'],
        'm,m,xb,s,s,d,h':['舅表舅表侄婿'],
        'm,m,xb,s,d&o':['舅表舅表姐'],
        'm,m,xb,s,d&o,h':['舅表舅表姐夫'],
        'm,m,xb,s,d&l':['舅表舅表妹'],
        'm,m,xb,s,d&l,h':['舅表舅表妹夫'],
        'm,m,xb,s,d,s':['舅表舅表甥男'],
        'm,m,xb,s,d,s,w':['舅表舅表甥妇'],
        'm,m,xb,s,d,d':['舅表舅表甥女'],
        'm,m,xb,s,d,d,h':['舅表舅表甥婿'],
        // 舅表姨表
        'm,m,xb,d':['舅表姨母','舅表姨妈','表姨母','表姨妈','表姨','表阿姨','舅表姨姨'],
        'm,m,xb,d,h':['舅表姨父','舅表姨丈','表姨父','表姨丈'],
        'm,m,xb,d,s&o':['舅表姨表哥'],
        'm,m,xb,d,s&o,w':['舅表姨表嫂'],
        'm,m,xb,d,s&l':['舅表姨表弟'],
        'm,m,xb,d,s&l,w':['舅表姨表弟媳'],
        'm,m,xb,d,s,s':['舅表姨表侄男'],
        'm,m,xb,d,s,s,w':['舅表姨表侄妇'],
        'm,m,xb,d,s,d':['舅表姨表侄女'],
        'm,m,xb,d,s,d,h':['舅表姨表侄婿'],
        'm,m,xb,d,d&o':['舅表姨表姐'],
        'm,m,xb,d,d&o,h':['舅表姨表姐夫'],
        'm,m,xb,d,d&l':['舅表姨表妹'],
        'm,m,xb,d,d&l,h':['舅表姨表妹夫'],
        'm,m,xb,d,d,s':['舅表姨表甥男'],
        'm,m,xb,d,d,s,w':['舅表姨表甥妇'],
        'm,m,xb,d,d,d':['舅表姨表甥女'],
        'm,m,xb,d,d,d,h':['舅表姨表甥婿'],
        // 从母*
        'm,m,xs':['外姨婆','姨外祖母','姨姥姥','外姨祖母','从母姨外祖母'],
        'm,m,xs,h':['外姨公','姨外祖父','姨姥爷','外姨祖父','从母姨外祖父'],
        // 从母舅表
        'm,m,xs,s':['姨舅父','姨舅','从母舅父'],
        'm,m,xs,s,w':['姨舅母','从母舅母'],
        'm,m,xs,s,s&o':['从母舅表哥'],
        'm,m,xs,s,s&o,w':['从母舅表嫂'],
        'm,m,xs,s,s&l':['从母舅表弟'],
        'm,m,xs,s,s&l,w':['从母舅表弟媳'],
        'm,m,xs,s,s,s':['从母舅表侄男'],
        'm,m,xs,s,s,s,w':['从母舅表侄妇'],
        'm,m,xs,s,s,d':['从母舅表侄女'],
        'm,m,xs,s,s,d,h':['从母舅表侄婿'],
        'm,m,xs,s,d&o':['从母舅表姐'],
        'm,m,xs,s,d&o,h':['从母舅表姐夫'],
        'm,m,xs,s,d&l':['从母舅表妹'],
        'm,m,xs,s,d&l,h':['从母舅表妹夫'],
        'm,m,xs,s,d,s':['从母舅表甥男'],
        'm,m,xs,s,d,s,w':['从母舅表甥妇'],
        'm,m,xs,s,d,d':['从母舅表甥女'],
        'm,m,xs,s,d,d,h':['从母舅表甥婿'],
        // 再从母
        'm,m,xs,d':['姨姨母','姨姨','从母姨母'],
        'm,m,xs,d,h':['姨姨父','从母姨父','从母姨丈'],
        'm,m,xs,d,s&o':['再从母兄'],
        'm,m,xs,d,s&o,w':['再从母嫂'],
        'm,m,xs,d,s&l':['再从母弟'],
        'm,m,xs,d,s&l,w':['再从母弟媳'],
        'm,m,xs,d,s,s':['再从母侄男'],
        'm,m,xs,d,s,s,w':['再从母侄妇'],
        'm,m,xs,d,s,d':['再从母侄女'],
        'm,m,xs,d,s,d,h':['再从母侄婿'],
        'm,m,xs,d,d&o':['再从母姊'],
        'm,m,xs,d,d&o,h':['再从母姊夫'],
        'm,m,xs,d,d&l':['再从母妹'],
        'm,m,xs,d,d&l,h':['再从母妹夫'],
        'm,m,xs,d,d,s':['再从母甥男'],
        'm,m,xs,d,d,s,w':['再从母甥妇'],
        'm,m,xs,d,d,d':['再从母甥女'],
        'm,m,xs,d,d,d,h':['再从母甥婿'],
        // 舅表
        'm,xb':['舅舅','舅父','舅','娘舅','舅仔','母舅','舅爸','舅爹','阿舅','x舅'],
        'm,xb,w':['舅妈','舅母','妗子','妗妗','妗妈','妗母','阿妗','x舅妈'],
        'm,xb,w,f':['舅眷外祖父','舅眷王父','舅眷毑父','舅眷姥爷','眷姥爷'],
        'm,xb,w,m':['舅眷外祖女','舅眷王母','舅眷毑母','舅眷姥姥','眷姥姥'],
        'm,xb,w,xb':['舅眷舅父','眷舅父'],
        'm,xb,w,xb,w':['舅眷舅母','眷舅母'],
        'm,xb,w,xb,s&o':['舅眷舅表哥'],
        'm,xb,w,xb,s&o,w':['舅眷舅表嫂'],
        'm,xb,w,xb,s&l':['舅眷舅表弟'],
        'm,xb,w,xb,s&l,w':['舅眷舅表弟媳'],
        'm,xb,w,xb,s,s':['舅眷侄男'],
        'm,xb,w,xb,s,s,w':['舅眷侄妇'],
        'm,xb,w,xb,s,d':['舅眷侄女'],
        'm,xb,w,xb,s,d,h':['舅眷侄婿'],
        'm,xb,w,xb,d&o':['舅眷舅表姐'],
        'm,xb,w,xb,d&o,h':['舅眷舅表姐夫'],
        'm,xb,w,xb,d&l':['舅眷舅表妹'],
        'm,xb,w,xb,d&l,h':['舅眷舅表妹夫'],
        'm,xb,w,xb,d,s':['舅眷甥男'],
        'm,xb,w,xb,d,s,w':['舅眷甥妇'],
        'm,xb,w,xb,d,d':['舅眷甥女'],
        'm,xb,w,xb,d,d,h':['舅眷甥婿'],
        'm,xb,w,xs':['舅眷姨母','眷姨母'],
        'm,xb,w,xs,h':['舅眷姨父','眷姨父'],
        'm,xb,w,xs,s&o':['舅眷姨表哥'],
        'm,xb,w,xs,s&o,w':['舅眷姨表嫂'],
        'm,xb,w,xs,s&l':['舅眷姨表弟'],
        'm,xb,w,xs,s&l,w':['舅眷姨表弟媳'],
        'm,xb,w,xs,d&o':['舅眷姨表姐'],
        'm,xb,w,xs,d&o,h':['舅眷姨表姐夫'],
        'm,xb,w,xs,d&l':['舅眷姨表妹'],
        'm,xb,w,xs,d&l,h':['舅眷姨表妹夫'],
        'm,xb,s&o':['舅表哥','表哥','老表'],
        'm,xb,s&o,w':['舅表嫂','舅表兄妇','表嫂'],
        'm,xb,s&l':['舅表弟','表弟','老表'],
        'm,xb,s&l,w':['舅表弟媳','舅表弟妇','表弟媳','表弟妹'],
        'm,xb,s,s':['舅表侄男','表侄男','舅表侄','表侄'],
        'm,xb,s,s,w':['舅表侄妇','表侄妇'],
        'm,xb,s,s,s':['舅表侄孙男','表侄孙男','舅表侄孙','表侄孙'],
        'm,xb,s,s,s,w':['舅表侄孙妇','表侄孙妇'],
        'm,xb,s,s,d':['舅表侄孙女','表侄孙女','舅表侄孙','表侄孙'],
        'm,xb,s,s,d,h':['舅表侄孙婿','表侄孙婿'],
        'm,xb,s,d':['舅表侄女','表侄女','舅表侄','表侄'],
        'm,xb,s,d,h':['舅表侄婿','表侄婿'],
        'm,xb,s,d,s':['舅表侄外孙男','表侄外孙男','舅表侄外孙','表侄外孙'],
        'm,xb,s,d,s,w':['舅表侄外孙妇','表侄外孙妇'],
        'm,xb,s,d,d':['舅表侄外孙女','表侄外孙女','舅表侄外孙','表侄外孙'],
        'm,xb,s,d,d,h':['舅表侄外孙婿','表侄外孙婿'],
        'm,xb,d&o':['舅表姐','表姐','老表'],
        'm,xb,d&o,h':['舅表姐夫','表姐夫','表姐丈'],
        'm,xb,d&l':['舅表妹','表妹','老表'],
        'm,xb,d&l,h':['舅表妹夫','舅表妹婿','表妹夫'],
        'm,xb,d,s':['舅表甥男','舅表甥男','表甥男','表甥'],
        'm,xb,d,s,w':['舅表甥妇','表甥妇'],
        'm,xb,d,s,s':['舅表甥孙男','表甥孙男','舅表甥孙','表甥孙'],
        'm,xb,d,s,s,w':['舅表甥孙妇','表甥孙妇'],
        'm,xb,d,s,d':['舅表甥孙女','表甥孙女','舅表甥孙','表甥孙'],
        'm,xb,d,s,d,h':['舅表甥孙婿','表甥孙婿'],
        'm,xb,d,d':['舅表甥女','表甥女','表甥男','表甥'],
        'm,xb,d,d,h':['舅表甥婿','表甥婿'],
        'm,xb,d,d,s':['舅表甥外孙男','表甥外孙男','舅表甥外孙','表甥外孙'],
        'm,xb,d,d,s,w':['舅表甥外孙妇','表甥外孙妇'],
        'm,xb,d,d,d':['舅表甥外孙女','表甥外孙女','舅表甥外孙','表甥外孙'],
        'm,xb,d,d,d,h':['舅表甥外孙婿','表甥外孙婿'],
        'm,ob':['大舅','舅父'],
        'm,ob,w':['大舅妈'],
        'm,lb':['小舅','舅仔','舅父仔'],
        'm,lb,w':['小舅妈'],
        // 从母
        'm,os':['大姨','大姨妈','姨妈'],
        'm,os,h':['大姨父','大姨丈'],
        'm,ls':['小姨','小姨妈','姨仔'],
        'm,ls,h':['小姨父','小姨丈'],
        'm,xs':['姨妈','姨母','姨姨','姨娘','阿姨','姨','x姨','x姨妈'],
        'm,xs,h':['姨丈','姨父','姨爸','姨爹','姨婿','姨郎','x姨丈','x姨父'],
        'm,xs,h,f':['姨姻祖父','姨姻王父','姨姻爷爷','姻爷爷'],
        'm,xs,h,m':['姨姻祖母','姨姻王父','姨姻奶奶','姻奶奶'],
        'm,xs,h,ob':['姨姻伯父','姻伯父'],
        'm,xs,h,ob,w':['姨姻伯母','姻伯母'],
        'm,xs,h,lb':['姨姻叔父','姻叔父'],
        'm,xs,h,lb,w':['姨姻叔母','姻叔母'],
        'm,xs,h,xb,s&o':['姨姻叔表哥'],
        'm,xs,h,xb,s&o,w':['姨姻叔表嫂'],
        'm,xs,h,xb,s&l':['姨姻叔表弟'],
        'm,xs,h,xb,s&l,w':['姨姻叔表弟媳'],
        'm,xs,h,xb,s,s':['姨姻侄男'],
        'm,xs,h,xb,s,s,w':['姨姻侄妇'],
        'm,xs,h,xb,s,d':['姨姻侄女'],
        'm,xs,h,xb,s,d,h':['姨姻侄婿'],
        'm,xs,h,xb,d&o':['姨姻叔表姐'],
        'm,xs,h,xb,d&o,h':['姨姻叔表姐夫'],
        'm,xs,h,xb,d&l':['姨姻叔表妹'],
        'm,xs,h,xb,d&l,h':['姨姻叔表妹夫'],
        'm,xs,h,xb,d,s':['姨姻甥男'],
        'm,xs,h,xb,d,s,w':['姨姻甥妇'],
        'm,xs,h,xb,d,d':['姨姻甥女'],
        'm,xs,h,xb,d,d,h':['姨姻甥婿'],
        'm,xs,h,xs':['姨姻姑母','姻姑母'],
        'm,xs,h,xs,h':['姨姻姑父','姻姑父'],
        'm,xs,h,xs,s&o':['姨姻姑表哥'],
        'm,xs,h,xs,s&o,w':['姨姻姑表嫂'],
        'm,xs,h,xs,s&l':['姨姻姑表弟'],
        'm,xs,h,xs,s&l,w':['姨姻姑表弟媳'],
        'm,xs,h,xs,d&o':['姨姻姑表姐'],
        'm,xs,h,xs,d&o,h':['姨姻姑表姐夫'],
        'm,xs,h,xs,d&l':['姨姻姑表妹'],
        'm,xs,h,xs,d&l,h':['姨姻姑表妹夫'],
        'm,xs,s&o':['姨哥','姨兄','从母兄'],
        'm,xs,s&o,w':['姨嫂','姨兄妇','从母嫂','从母兄妇'],
        'm,xs,s&l':['姨弟','从母弟'],
        'm,xs,s&l,w':['姨弟媳','姨弟妇','从母弟妇'],
        'm,xs,s,w,f':['从母兄弟眷父'],
        'm,xs,s,w,m':['从母兄弟眷母'],
        'm,xs,s,w,xb&o':['从母兄弟眷兄'],
        'm,xs,s,w,xb&o,w':['从母兄弟眷兄妇'],
        'm,xs,s,w,xb&l':['从母兄弟眷弟'],
        'm,xs,s,w,xb&l,w':['从母兄弟眷弟妇'],
        'm,xs,s,w,xs&o':['从母兄弟眷姊'],
        'm,xs,s,w,xs&o,h':['从母兄弟眷姊婿'],
        'm,xs,s,w,xs&l':['从母兄弟眷妹'],
        'm,xs,s,w,xs&l,h':['从母兄弟眷妹婿'],
        'm,xs,s,s':['姨侄男','从母侄男','姨侄'],
        'm,xs,s,s,w':['姨侄妇','从母侄妇'],
        'm,xs,s,s,s':['姨侄孙男','从母侄孙男','姨侄孙','从母侄孙'],
        'm,xs,s,s,s,w':['姨侄孙妇','从母侄孙妇'],
        'm,xs,s,s,d':['姨侄孙女','从母侄孙女','姨侄孙','从母侄孙'],
        'm,xs,s,s,d,h':['姨侄孙婿','从母侄孙婿'],
        'm,xs,s,d':['姨侄女','从母侄女','姨侄'],
        'm,xs,s,d,h':['姨侄婿','从母侄婿'],
        'm,xs,s,d,s':['姨侄外孙男','从母侄外孙男','姨侄外孙','从母侄外孙'],
        'm,xs,s,d,s,w':['姨侄外孙妇','从母侄外孙妇'],
        'm,xs,s,d,d':['姨侄外孙女','从母侄外孙女','姨侄外孙','从母侄外孙'],
        'm,xs,s,d,d,h':['姨侄外孙婿','从母侄外孙婿'],
        'm,xs,d&o':['姨姐','从母姐'],
        'm,xs,d&o,h':['姨姐夫','从母姐夫','从母姊丈','从母姊婿','从母姊郎'],
        'm,xs,d&l':['姨妹','从母妹'],
        'm,xs,d&l,h':['姨妹夫','从母妹夫','从母妹丈','从母妹婿','从母妹郎'],
        'm,xs,d,h,f':['从母姊妹姻父'],
        'm,xs,d,h,m':['从母姊妹姻母'],
        'm,xs,d,h,xb&o':['从母姊妹姻兄'],
        'm,xs,d,h,xb&o,w':['从母姊妹姻兄妇'],
        'm,xs,d,h,xb&l':['从母姊妹姻弟'],
        'm,xs,d,h,xb&l,w':['从母姊妹姻弟妇'],
        'm,xs,d,h,xs&o':['从母姊妹姻姊'],
        'm,xs,d,h,xs&o,h':['从母姊妹姻姊婿'],
        'm,xs,d,h,xs&l':['从母姊妹姻妹'],
        'm,xs,d,h,xs&l,h':['从母姊妹姻妹婿'],
        'm,xs,d,s':['姨甥男','从母甥男','姨外甥','姨甥'],
        'm,xs,d,s,w':['姨甥妇','从母甥妇'],
        'm,xs,d,s,s':['姨甥孙男','从母甥孙男','姨甥孙','从母甥孙'],
        'm,xs,d,s,s,w':['姨甥孙妇','从母甥孙妇'],
        'm,xs,d,s,d':['姨甥孙女','从母甥孙女','姨甥孙','从母甥孙'],
        'm,xs,d,s,d,h':['姨甥孙婿','从母甥孙婿'],
        'm,xs,d,d':['姨甥女','从母甥女','姨外甥女','姨甥'],
        'm,xs,d,d,h':['姨甥婿','从母甥婿'],
        'm,xs,d,d,s':['姨甥外孙男','从母甥外孙男','姨甥外孙','从母甥外孙'],
        'm,xs,d,d,s,w':['姨甥外孙妇','从母甥外孙妇'],
        'm,xs,d,d,d':['姨甥外孙女','从母甥外孙女','姨甥外孙','从母甥外孙'],
        'm,xs,d,d,d,h':['姨甥外孙婿','从母甥外孙婿'],
        // 婆家
        'h':['老公','丈夫','先生','官人','男人','汉子','夫','夫君','相公','夫婿','良人','爱人','老伴','老头子'],
        'h,f':['公公','翁亲','老公公'],
        'h,f,f':['祖公','祖翁','奶公父'],
        'h,f,f,f':['曾祖公','太公翁'],
        'h,f,f,f,ob':['伯曾祖公','太伯翁'],
        'h,f,f,f,ob,w':['伯曾祖婆','太姆婆'],
        'h,f,f,f,lb':['叔曾祖公','太叔翁'],
        'h,f,f,f,lb,w':['叔曾祖婆','太婶婆'],
        'h,f,f,m':['曾祖婆','太奶亲'],
        'h,f,f,ob':['伯祖公','伯祖翁'],
        'h,f,f,ob,w':['伯祖婆'],
        'h,f,f,lb':['叔祖公','叔祖翁'],
        'h,f,f,lb,w':['叔祖婆'],
        'h,f,f,xb,s&o':['堂伯老爷'],
        'h,f,f,xb,s&o,w':['堂伯奶奶'],
        'h,f,f,xb,s&l':['堂叔老爷'],
        'h,f,f,xb,s&l,w':['堂叔奶奶'],
        'h,f,f,xb,s,s&o':['从堂大伯'],
        'h,f,f,xb,s,s&o,w':['从堂嫂'],
        'h,f,f,xb,s,s&l':['从堂叔仔'],
        'h,f,f,xb,s,s&l,w':['从堂弟媳'],
        'h,f,f,xb,s,d&o':['从堂大姑'],
        'h,f,f,xb,s,d&o,h':['从堂大姑夫'],
        'h,f,f,xb,s,d&l':['从堂小姑'],
        'h,f,f,xb,s,d&l,h':['从堂小姑夫'],
        'h,f,f,xb,d':['堂姑奶奶'],
        'h,f,f,xb,d,h':['堂姑老爷'],
        'h,f,f,xb,d,d&o':['堂姑表大姑'],
        'h,f,f,xb,d,d&o,h':['堂姑表大姑夫'],
        'h,f,f,xb,d,d&l':['堂姑表小姑'],
        'h,f,f,xb,d,d&l,h':['堂姑表小姑夫'],
        'h,f,f,xs':['姑祖婆'],
        'h,f,f,xs,h':['姑祖公'],
        'h,f,m':['祖婆','奶婆母'],
        'h,f,m,f':['曾外祖公'],
        'h,f,m,m':['曾外祖婆'],
        'h,f,m,xb':['舅祖公'],
        'h,f,m,xb,w':['舅祖婆'],
        'h,f,m,xs':['姨祖婆'],
        'h,f,m,xs,h':['姨祖公'],
        'h,f,ob':['伯公父','伯翁'],
        'h,f,ob,w':['伯婆母','伯婆'],
        'h,f,lb':['叔公父','叔公','叔翁','叔祖'],
        'h,f,lb,w':['叔婆母','叔婆','婶婆','婶亲'],
        'h,f,xb,s&o':['堂大伯子','从父大伯子','从父大伯兄','堂大伯','从父大伯','夫从兄'],
        'h,f,xb,s&o,w':['堂大伯嫂','从父大伯嫂','堂大姆','从父大姆','从兄嫂'],
        'h,f,xb,s&l':['堂小叔弟','从父小叔弟','堂叔仔','从父叔仔','夫从弟'],
        'h,f,xb,s&l,w':['堂小叔弟妇','从父小叔弟妇','堂小弟','从父小弟','从弟妇'],
        'h,f,xb,s,s':['堂夫侄男','从父夫侄男'],
        'h,f,xb,s,d':['堂夫侄女','从父夫侄女'],
        'h,f,xb,d&o':['堂大姑姐','从父大姑姐'],
        'h,f,xb,d&o,h':['堂大姑姐夫','从父大姑姐夫'],
        'h,f,xb,d&l':['堂小姑妹','从父小姑妹'],
        'h,f,xb,d&l,h':['堂小姑妹夫','从父小姑妹夫'],
        'h,f,xb,d,s':['堂夫甥男','从父夫甥男'],
        'h,f,xb,d,d':['堂夫甥女','从父夫甥女'],
        'h,f,xs':['姑婆母','姑婆'],
        'h,f,xs,h':['姑公父','姑公'],
        'h,f,xs,s&o':['姑表大伯子','姑表大伯兄','表大伯'],
        'h,f,xs,s&o,w':['姑表大伯嫂','表大姆'],
        'h,f,xs,s&l':['姑表小叔弟','表叔仔'],
        'h,f,xs,s&l,w':['姑表小叔弟妇','表小弟'],
        'h,f,xs,s,s':['姑表夫侄男'],
        'h,f,xs,s,d':['姑表夫侄女'],
        'h,f,xs,d&o':['姑表大姑姐','表大姑'],
        'h,f,xs,d&o,h':['姑表大姑姐夫'],
        'h,f,xs,d&l':['姑表小姑妹','表姑仔'],
        'h,f,xs,d&l,h':['姑表小姑妹夫'],
        'h,f,xs,d,s':['姑表夫甥男'],
        'h,f,xs,d,d':['姑表夫甥女'],
        'h,m':['婆婆','婆母','姑亲','老婆婆'],
        'h,m,f':['外祖公','姥公父','姥公'],
        'h,m,f,f':['外曾祖公'],
        'h,m,f,m':['外曾祖婆'],
        'h,m,f,ob':['伯外祖公'],
        'h,m,f,ob,w':['伯外祖婆'],
        'h,m,f,lb':['叔外祖公'],
        'h,m,f,lb,w':['叔外祖婆'],
        'h,m,f,xs':['姑外祖婆'],
        'h,m,f,xs,h':['姑外祖公'],
        'h,m,m':['外祖婆','姥婆母','姥婆'],
        'h,m,m,f':['外曾外祖公'],
        'h,m,m,m':['外曾外祖婆'],
        'h,m,m,xb':['舅外祖公'],
        'h,m,m,xb,w':['舅外祖婆'],
        'h,m,m,xs':['姨外祖婆'],
        'h,m,m,xs,h':['姨外祖公'],
        'h,m,xb':['舅公父','舅公'],
        'h,m,xb,w':['舅婆母','舅婆'],
        'h,m,xb,s&o':['舅表大伯子','舅表大伯兄','表大伯'],
        'h,m,xb,s&o,w':['舅表大伯嫂','表大姆'],
        'h,m,xb,s&l':['舅表小叔弟','表叔仔'],
        'h,m,xb,s&l,w':['舅表小叔弟妇','表小弟'],
        'h,m,xb,s,s':['舅表夫侄男'],
        'h,m,xb,s,d':['舅表夫侄女'],
        'h,m,xb,d&o':['舅表大姑姐','表大姑'],
        'h,m,xb,d&o,h':['舅表大姑姐夫'],
        'h,m,xb,d&l':['舅表小姑妹','表姑仔'],
        'h,m,xb,d&l,h':['舅表小姑妹夫'],
        'h,m,xb,d,s':['舅表夫甥男'],
        'h,m,xb,d,d':['舅表夫甥女'],
        'h,m,xs':['姨婆母','姨婆'],
        'h,m,xs,h':['姨公父','姨公'],
        'h,m,xs,s&o':['姨大伯子','从母大伯子','从母大伯兄','姨大伯','从母大伯'],
        'h,m,xs,s&o,w':['姨大伯嫂','从母大伯嫂','姨大姆','从母大姆'],
        'h,m,xs,s&l':['姨小叔弟','从母小叔弟','姨叔仔','从母叔仔'],
        'h,m,xs,s&l,w':['姨小叔弟妇','从母小叔弟妇','姨小弟','从母小弟'],
        'h,m,xs,s,s':['姨夫侄男','从母夫侄男'],
        'h,m,xs,s,d':['姨夫侄女','从母夫侄女'],
        'h,m,xs,d&o':['姨大姑姐','从母大姑姐'],
        'h,m,xs,d&o,h':['姨大姑姐夫','从母大姑姐夫'],
        'h,m,xs,d&l':['姨小姑妹','从母小姑妹'],
        'h,m,xs,d&l,h':['姨小姑妹夫','从母小姑妹夫'],
        'h,m,xs,d,s':['姨夫甥男','从母夫甥男'],
        'h,m,xs,d,d':['姨夫甥女','从母夫甥女'],
        'h,ob':['大伯子','大伯哥','大伯兄','夫兄'],
        'h,ob,w':['大婶子','伯嫂','大伯嫂','大伯兄妇','大伯妇','伯娘','大伯娘','大嫂','夫兄嫂','妯娌'],
        'h,lb':['小叔子','小叔弟'],
        'h,lb,w':['小婶子','小婶','叔嫂','小叔妇','小叔媳妇','小叔弟妇','妯娌'],
        'h,xb':['伯叔'],
        'h,xb,s':['婆家侄','叔侄男','叔伯男','从男','婆家侄男'],
        'h,xb,s,w':['叔侄媳妇','叔伯侄妇','叔伯妇','叔侄妇'],
        'h,xb,s,s':['叔侄孙男'],
        'h,xb,s,s,w':['叔侄孙妇'],
        'h,xb,s,d':['叔侄孙女'],
        'h,xb,s,d,h':['叔侄孙婿'],
        'h,xb,d':['叔侄女','叔伯女','从女','婆家侄女'],
        'h,xb,d,h':['叔侄婿'],
        'h,xb,d,s':['叔侄外孙男'],
        'h,xb,d,s,w':['叔侄外孙妇'],
        'h,xb,d,d':['叔侄外孙女'],
        'h,xb,d,d,h':['叔侄外孙婿'],
        'h,os':['大姑子','大姑','大娘姑','大姑姐','夫姐'],
        'h,os,h':['大姑夫','姊丈','大姑姐夫'],
        'h,ls':['小姑子','小姑','小姑妹','夫妹'],
        'h,ls,h':['小姑夫','小亘子','小姑妹夫'],
        'h,xs,s':['姑甥男','姑男','婆家甥男'],
        'h,xs,s,w':['姑甥妇','姑妇'],
        'h,xs,s,s':['姑甥孙男'],
        'h,xs,s,s,w':['姑甥孙妇'],
        'h,xs,s,d':['姑甥孙女'],
        'h,xs,s,d,h':['姑甥孙婿'],
        'h,xs,d':['姑甥女','姑女','婆家甥女'],
        'h,xs,d,h':['姑甥婿'],
        'h,xs,d,s':['姑甥外孙男'],
        'h,xs,d,s,w':['姑甥外孙妇'],
        'h,xs,d,d':['姑甥外孙女'],
        'h,xs,d,d,h':['姑甥外孙婿'],
        // 岳家
        'w':['老婆','妻子','太太','媳妇儿','媳妇','夫人','女人','婆娘','妻','内人','娘子','爱人','爱妻','老伴','老太婆'],
        'w,f':['岳父','岳丈','老丈人','丈人','泰山','妻父'],
        'w,f,f':['祖岳父','岳祖父','太岳父','奶岳父'],
        'w,f,f,f':['曾祖岳父','岳曾祖父','曾祖丈人'],
        'w,f,f,f,xb,s,s&o':['姻伯丈'],
        'w,f,f,f,xb,s,s&o,w':['姻姆'],
        'w,f,f,f,xb,s,s&l':['姻叔丈'],
        'w,f,f,f,xb,s,s&l,w':['姻婶'],
        'w,f,f,m':['曾祖岳母','岳曾祖母','曾祖丈母'],
        'w,f,f,ob':['伯祖岳父','岳伯祖父','太伯岳'],
        'w,f,f,ob,w':['伯祖岳母','岳伯祖母','太伯岳母'],
        'w,f,f,lb,':['叔祖岳父','岳叔祖父','太叔岳'],
        'w,f,f,lb,w':['叔祖岳母','岳叔祖母','太叔岳母'],
        'w,f,f,xb,s&o':['姻伯'],
        'w,f,f,xb,s&o,w':['姻姆'],
        'w,f,f,xb,s&l':['姻叔'],
        'w,f,f,xb,s&l,w':['姻婶'],
        'w,f,f,xs':['姑祖岳母','岳姑祖母','太姑岳母'],
        'w,f,f,xs,h':['姑祖岳父','岳姑祖父','太姑岳父'],
        'w,f,m':['祖岳母','岳祖母','太岳母','奶岳母'],
        'w,f,m,f':['曾外祖岳父','岳曾外祖父','曾外祖丈人'],
        'w,f,m,m':['曾外祖岳母','岳曾外祖母','曾外祖丈母'],
        'w,f,m,xb':['舅祖岳父','岳舅祖父','太舅岳父'],
        'w,f,m,xb,w':['舅祖岳母','岳舅祖母','太舅岳母'],
        'w,f,m,xs':['姨祖岳母','岳姨祖母','太姨岳母'],
        'w,f,m,xs,h':['姨祖岳父','岳姨祖父','太姨岳父'],
        'w,f,ob':['伯岳','伯岳父'],
        'w,f,ob,w':['伯岳母'],
        'w,f,lb':['叔岳','叔岳父'],
        'w,f,lb,w':['叔岳母'],
        'w,f,xb,s&o':['内堂舅兄','内堂大舅','内堂大舅兄','堂大舅兄','从父大舅兄','堂大舅','内堂兄','堂内兄'],
        'w,f,xb,s&o,w':['内堂舅嫂','内堂嫂','堂内嫂','从父内嫂'],
        'w,f,xb,s&l':['内堂舅弟','内堂舅仔','内堂小舅弟','堂小舅弟','从父小舅弟','堂舅仔','内堂弟','堂内弟'],
        'w,f,xb,s&l,w':['内堂舅弟媳','内堂弟妇','堂内弟妇','从父内弟妇'],
        'w,f,xb,d&o':['内堂姨姐','内堂大姨姐','堂大姨姐','从父大姨姐','堂大姨','内堂姐','堂内姐'],
        'w,f,xb,d&o,h':['内堂姨姐夫','内堂襟兄','堂襟兄','从父襟兄'],
        'w,f,xb,d&l':['内堂姨妹','内堂小姨妹','堂小姨妹','从父小姨妹','堂姨仔','内堂妹','堂内妹'],
        'w,f,xb,d&l,h':['内堂姨妹夫','内堂襟弟','堂襟弟','从父襟弟'],
        'w,f,xs':['姑岳母'],
        'w,f,xs,h':['姑岳父'],
        'w,f,xs,s&o':['内姑表舅兄','内姑表大舅','内姑表大舅兄','表大舅兄','表大舅','内表兄','表内兄'],
        'w,f,xs,s&o,w':['内姑表舅嫂','内表嫂','表内嫂'],
        'w,f,xs,s&l':['内姑表舅弟','内姑表舅仔','内姑表小舅弟','表小舅弟','表舅仔','内表弟','表内弟'],
        'w,f,xs,s&l,w':['内姑表舅弟媳','内表弟妇','表内弟妇'],
        'w,f,xs,d&o':['内姑表姨姐','内姑表大姨姐','表大姨姐','表大姨','内表姐','表内姐'],
        'w,f,xs,d&o,h':['内姑表姨姐夫','内姑表襟兄','姑表襟兄','表襟兄'],
        'w,f,xs,d&l':['内姑表姨妹','内姑表小姨妹','表小姨妹','表姨仔','内表妹','表内妹'],
        'w,f,xs,d&l,h':['内姑表姨妹夫','内姑表襟弟','姑表襟弟','表襟弟'],
        'w,m':['岳母','丈母娘','老丈母','丈母','泰水'],
        'w,m,f':['外祖岳父','岳外祖父','外祖丈人','丈人外祖父','外太岳父','姥岳父','姥丈人','丈人姥爷'],
        'w,m,f,f':['外曾祖岳父','岳外曾祖父','外曾祖丈人'],
        'w,m,f,m':['外曾祖岳母','岳外曾祖母','外曾祖丈母'],
        'w,m,f,ob':['伯外祖岳父','岳伯外祖父'],
        'w,m,f,ob,w':['伯外祖岳母','岳伯外祖母'],
        'w,m,f,lb':['叔外祖岳父','岳叔外祖父'],
        'w,m,f,lb,w':['叔外祖岳母','岳叔外祖母'],
        'w,m,f,xs':['姑外祖岳母','岳姑外祖母'],
        'w,m,f,xs,h':['姑外祖岳父','岳姑外祖父'],
        'w,m,m':['外祖岳母','岳外祖母','外祖丈母娘','外祖丈母','丈人外祖母','外太岳母','姥岳母','姥丈母','丈人姥姥'],
        'w,m,m,f':['外曾外祖岳父','岳外曾外祖父','外曾外祖丈人'],
        'w,m,m,m':['外曾外祖岳母','岳外曾外祖母','外曾外祖丈母'],
        'w,m,m,xb':['舅外祖岳父','岳舅外祖父'],
        'w,m,m,xb,w':['舅外祖岳母','岳舅外祖母'],
        'w,m,m,xs':['姨外祖岳母','岳姨外祖母'],
        'w,m,m,xs,h':['姨外祖岳父','岳姨外祖父'],
        'w,m,xb':['舅岳父'],
        'w,m,xb,w':['舅岳母'],
        'w,m,xb,s&o':['内舅表舅兄','内舅表大舅','内舅表大舅兄','表大舅兄','表大舅','内表兄','表内兄'],
        'w,m,xb,s&o,w':['内舅表舅嫂','内表嫂','表内嫂'],
        'w,m,xb,s&l':['内舅表舅弟','内舅表舅仔','内舅表小舅弟','表小舅弟','表舅仔','内表弟','表内弟'],
        'w,m,xb,s&l,w':['内舅表舅弟媳','舅表弟妇','表内弟妇'],
        'w,m,xb,d&o':['内舅表姨姐','内舅表大姨姐','表大姨姐','表大姨','内表姐','表内姐'],
        'w,m,xb,d&o,h':['内舅表姨姐夫','内舅表襟兄','舅表襟兄','表襟兄'],
        'w,m,xb,d&l':['内舅表姨妹','内舅表小姨妹','表小姨妹','表姨仔','内表妹','表内妹'],
        'w,m,xb,d&l,h':['内舅表姨妹夫','内舅表襟弟','舅表襟弟','表襟弟'],
        'w,m,xs':['姨岳母'],
        'w,m,xs,h':['姨岳父'],
        'w,m,xs,s&o':['内姨舅兄','内姨大舅','内姨大舅兄','姨大舅兄','从母大舅兄','姨大舅','内姨兄','姨内兄'],
        'w,m,xs,s&o,w':['内姨舅嫂','内姨嫂','姨内嫂','从母内嫂'],
        'w,m,xs,s&l':['内姨舅弟','内姨舅仔','内姨小舅弟','姨小舅弟','从母小舅弟','姨舅仔','内姨弟','姨内弟'],
        'w,m,xs,s&l,w':['内姨舅弟媳','内姨弟妇','姨内弟妇','从母内弟妇'],
        'w,m,xs,d&o':['内姨姨姐','内姨大姨姐','姨大姨姊','从母大姨姐','姨大姨','内姨姐','姨内姐'],
        'w,m,xs,d&o,h':['内姨姨姐夫','内姨襟兄','姨襟兄','从母襟兄'],
        'w,m,xs,d&l':['内姨姨妹','内姨小姨妹','姨小姨妹','从母小姨妹','姨姨仔','内姨妹','姨内妹'],
        'w,m,xs,d&l,h':['内姨姨妹夫','内姨襟弟','姨襟弟','从母襟弟'],
        'w,ob':['大舅子','大舅哥','大舅兄','内兄','妻兄','妻舅','舅兄'],
        'w,ob,w':['舅嫂','大舅妇','大舅嫂','大舅兄妇','大舅媳妇','大妗子','内嫂','妻兄嫂'],
        'w,lb':['小舅子','小舅弟','内弟','妻弟','妻舅','舅弟'],
        'w,lb,w':['舅弟媳','小舅妇','小舅弟妇','小舅媳妇','小妗子','妻妹夫'],
        'w,xb,s':['内侄','内侄男','妻侄男','舅侄男','岳侄男','丈人侄男','舅男'],
        'w,xb,s,w':['内侄媳妇','内侄妇','妻侄妇','舅侄妇','岳侄妇','丈人侄妇','舅妇'],
        'w,xb,s,s':['内侄孙','内侄孙男','妻侄孙男'],
        'w,xb,s,s,w':['内侄孙妇','妻侄孙妇'],
        'w,xb,s,s,s':['内曾侄孙','内曾侄孙男'],
        'w,xb,s,s,s,w':['内曾侄孙妇'],
        'w,xb,s,s,d':['内曾侄孙女'],
        'w,xb,s,s,d,h':['内曾侄孙婿'],
        'w,xb,s,d':['内侄孙女','妻侄孙女'],
        'w,xb,s,d,h':['内侄孙婿','妻侄孙婿'],
        'w,xb,d':['内侄女','内侄','妻侄女','舅侄女','岳侄女','丈人侄女','舅女'],
        'w,xb,d,h':['内侄女婿','妻侄婿','舅侄婿','岳侄婿','丈人侄婿'],
        'w,xb,d,s':['内侄外孙','内侄外孙男','姨侄外孙男'],
        'w,xb,d,s,w':['内侄外孙妇','姨侄外孙妇'],
        'w,xb,d,d':['内侄外孙女','姨侄外孙女'],
        'w,xb,d,d,h':['内侄外孙婿','姨侄外孙婿'],
        'w,os':['大姨子','大姨姐','妻姐'],
        'w,os,h':['大姨夫','大姨姐夫','襟兄','连襟','连桥','姨夫'],
        'w,ls':['小姨子','小姨妹','妻妹','小妹儿'],
        'w,ls,h':['小姨夫','小姨妹夫','襟弟','连襟','连桥','姨夫'],
        'w,xs,s':['内甥男','内甥','妻甥男','姨甥男','岳甥男','丈人甥男','姨男','从男'],
        'w,xs,s,w':['内甥妇','姨甥妇','岳甥妇','丈人甥妇','姨妇'],
        'w,xs,s,s':['内甥孙男','姨甥孙男'],
        'w,xs,s,s,w':['内甥孙妇','姨甥孙妇'],
        'w,xs,s,d':['内甥孙女','姨甥孙女'],
        'w,xs,s,d,h':['内甥孙婿','姨甥孙婿'],
        'w,xs,d':['内甥女','内甥','姨甥女','妻外甥女','丈人甥女','姨女','从女'],
        'w,xs,d,h':['内甥婿','姨甥婿','妻甥婿','岳甥婿','丈人甥婿'],
        'w,xs,d,s':['内甥外孙男','姨甥外孙男'],
        'w,xs,d,s,w':['内甥外孙妇','姨甥外孙妇'],
        'w,xs,d,d':['内甥外孙女','姨甥外孙女'],
        'w,xs,d,d,h':['内甥外孙婿','姨甥外孙婿'],
        // 兄弟
        'ob':['哥哥','哥','兄','老哥','兄长','阿哥','大佬','吖哥','胞哥','大哥','x哥'],
        'ob,w':['嫂子','嫂','嫂嫂','兄嫂','大嫂','阿嫂','x嫂'],
        'lb':['弟弟','弟','胞弟','老弟','阿弟','细佬','x弟'],
        'lb,w':['弟妹','弟媳','弟媳妇','弟妇','x弟妹'],
        'xb':['兄弟'],
        'xb,w,f':['兄弟眷父'],
        'xb,w,f,f':['兄弟眷祖父','兄弟眷奶爷','兄弟眷王父'],
        'xb,w,f,f,ob':['兄弟眷伯奶爷','兄弟眷伯王父'],
        'xb,w,f,f,ob,w':['兄弟眷伯奶奶','兄弟眷伯王母'],
        'xb,w,f,f,lb':['兄弟眷叔奶爷','兄弟眷叔王父'],
        'xb,w,f,f,lb,w':['兄弟眷叔奶奶','兄弟眷叔王母'],
        'xb,w,f,f,xs':['兄弟眷姑奶奶','兄弟眷姑王母'],
        'xb,w,f,f,xs,h':['兄弟眷姑奶爷','兄弟眷姑王父'],
        'xb,w,f,m':['兄弟眷祖母','兄弟眷奶奶','兄弟眷王母'],
        'xb,w,f,m,xb':['兄弟眷舅奶爷','兄弟眷舅王父'],
        'xb,w,f,m,xb,w':['兄弟眷舅奶奶','兄弟眷舅王母'],
        'xb,w,f,m,xs':['兄弟眷姨奶奶','兄弟眷姨王母'],
        'xb,w,f,m,xs,h':['兄弟眷姨奶爷','兄弟眷姨王父'],
        'xb,w,f,ob':['兄弟眷伯父'],
        'xb,w,f,ob,w':['兄弟眷伯母'],
        'xb,w,f,lb':['兄弟眷叔父'],
        'xb,w,f,lb,w':['兄弟眷叔母'],
        'xb,w,f,xb,s&o':['兄弟眷叔表兄'],
        'xb,w,f,xb,s&o,w':['兄弟眷叔表兄妇'],
        'xb,w,f,xb,s&l':['兄弟眷叔表弟'],
        'xb,w,f,xb,s&l,w':['兄弟眷叔表弟妇'],
        'xb,w,f,xb,d&o':['兄弟眷叔表姊'],
        'xb,w,f,xb,d&o,h':['兄弟眷叔表姊婿'],
        'xb,w,f,xb,d&l':['兄弟眷叔表妹'],
        'xb,w,f,xb,d&l,h':['兄弟眷叔表妹婿'],
        'xb,w,f,xs':['兄弟眷姑母'],
        'xb,w,f,xs,h':['兄弟眷姑父'],
        'xb,w,f,xs,s&o':['兄弟眷姑表兄'],
        'xb,w,f,xs,s&o,w':['兄弟眷姑表兄妇'],
        'xb,w,f,xs,s&l':['兄弟眷姑表弟'],
        'xb,w,f,xs,s&l,w':['兄弟眷姑表弟妇'],
        'xb,w,f,xs,d&o':['兄弟眷姑表姊'],
        'xb,w,f,xs,d&o,h':['兄弟眷姑表姊婿'],
        'xb,w,f,xs,d&l':['兄弟眷姑表妹'],
        'xb,w,f,xs,d&l,h':['兄弟眷姑表妹婿'],
        'xb,w,m':['兄弟眷母'],
        'xb,w,m,f':['兄弟眷外祖父','兄弟眷姥爷','兄弟眷王父'],
        'xb,w,m,f,ob':['兄弟眷伯姥爷','兄弟眷伯王父'],
        'xb,w,m,f,ob,w':['兄弟眷伯姥姥','兄弟眷伯王母'],
        'xb,w,m,f,lb':['兄弟眷叔姥爷','兄弟眷叔王父'],
        'xb,w,m,f,lb,w':['兄弟眷叔姥姥','兄弟眷叔王母'],
        'xb,w,m,f,xs':['兄弟眷姑姥姥','兄弟眷姑王母'],
        'xb,w,m,f,xs,h':['兄弟眷姑姥爷','兄弟眷姑王父'],
        'xb,w,m,m':['兄弟眷外祖母','兄弟眷姥姥','兄弟眷王母'],
        'xb,w,m,m,xb':['兄弟眷舅姥爷','兄弟眷舅王父'],
        'xb,w,m,m,xb,w':['兄弟眷舅姥姥','兄弟眷舅王母'],
        'xb,w,m,m,xs':['兄弟眷姨姥姥','兄弟眷姨王母'],
        'xb,w,m,m,xs,h':['兄弟眷姨姥爷','兄弟眷姨王父'],
        'xb,w,m,xb':['兄弟眷舅父'],
        'xb,w,m,xb,w':['兄弟眷舅母'],
        'xb,w,m,xb,s&o':['兄弟眷舅表兄'],
        'xb,w,m,xb,s&o,w':['兄弟眷舅表兄妇'],
        'xb,w,m,xb,s&l':['兄弟眷舅表弟'],
        'xb,w,m,xb,s&l,w':['兄弟眷舅表弟妇'],
        'xb,w,m,xb,d&o':['兄弟眷舅表姊'],
        'xb,w,m,xb,d&o,h':['兄弟眷舅表姊婿'],
        'xb,w,m,xb,d&l':['兄弟眷舅表妹'],
        'xb,w,m,xb,d&l,h':['兄弟眷舅表妹婿'],
        'xb,w,m,xs':['兄弟眷姨母'],
        'xb,w,m,xs,h':['兄弟眷姨父'],
        'xb,w,m,xs,s&o':['兄弟眷姨表兄'],
        'xb,w,m,xs,s&o,w':['兄弟眷姨表兄妇'],
        'xb,w,m,xs,s&l':['兄弟眷姨表弟'],
        'xb,w,m,xs,s&l,w':['兄弟眷姨表弟妇'],
        'xb,w,m,xs,d&o':['兄弟眷姨表姊'],
        'xb,w,m,xs,d&o,h':['兄弟眷姨表姊婿'],
        'xb,w,m,xs,d&l':['兄弟眷姨表妹'],
        'xb,w,m,xs,d&l,h':['兄弟眷姨表妹婿'],
        'xb,w,xb&o':['兄弟眷兄'],
        'xb,w,xb&o,w':['兄弟眷兄妇'],
        'xb,w,xb&l':['兄弟眷弟'],
        'xb,w,xb&l,w':['兄弟眷弟妇'],
        'xb,w,xb,s':['兄弟眷侄男'],
        'xb,w,xb,s,w':['兄弟眷侄妇'],
        'xb,w,xb,d':['兄弟眷侄女'],
        'xb,w,xb,d,h':['兄弟眷侄婿'],
        'xb,w,xs&o':['兄弟眷姊'],
        'xb,w,xs&o,h':['兄弟眷姊婿'],
        'xb,w,xs&l':['兄弟眷妹'],
        'xb,w,xs&l,h':['兄弟眷妹婿'],
        'xb,w,xs,s':['兄弟眷甥男'],
        'xb,w,xs,s,w':['兄弟眷甥妇'],
        'xb,w,xs,d':['兄弟眷甥女'],
        'xb,w,xs,d,h':['兄弟眷甥婿'],
        '0,xb,w,xb,s':['舅眷舅男'],
        '1,xb,w,xb,s':['叔眷舅男'],
        '0,xb,w,xb,d':['舅眷舅女'],
        '1,xb,w,xb,d':['叔眷舅女'],
        '0,xb,w,xs,s':['舅眷姨男'],
        '1,xb,w,xs,s':['叔眷姨男'],
        '0,xb,w,xs,d':['舅眷姨女'],
        '1,xb,w,xs,d':['叔眷姨女'],
        'xb,s':['侄子','侄男','侄男儿','侄儿','阿侄','侄'],
        'xb,s,w':['侄媳妇','侄妇'],
        'xb,s,w,f&o':['侄眷兄'],
        'xb,s,w,f&l':['侄眷弟'],
        'xb,s,w,f,f':['侄眷父'],
        'xb,s,w,f,m':['侄眷母'],
        'xb,s,w,m&o':['侄眷姊'],
        'xb,s,w,m&l':['侄眷妹'],
        'xb,s,w,m,f':['侄眷父'],
        'xb,s,w,m,m':['侄眷母'],
        'xb,s,w,xb':['侄眷男'],
        'xb,s,w,xb,w':['侄眷妇'],
        'xb,s,w,xs':['侄眷女'],
        'xb,s,w,xs,h':['侄眷婿'],
        'xb,s,s':['侄孙男','侄孙子','从孙男'],
        'xb,s,s,w':['侄孙妇','从孙妇'],
        'xb,s,s,w,f':['侄孙眷男'],
        'xb,s,s,w,f,f&o':['侄孙眷兄'],
        'xb,s,s,w,f,f&l':['侄孙眷弟'],
        'xb,s,s,w,f,m&o':['侄孙眷姊'],
        'xb,s,s,w,f,m&l':['侄孙眷妹'],
        'xb,s,s,w,m':['侄孙眷女'],
        'xb,s,s,w,m,f&o':['侄孙眷兄'],
        'xb,s,s,w,m,f&l':['侄孙眷弟'],
        'xb,s,s,w,m,m&o':['侄孙眷姊'],
        'xb,s,s,w,m,m&l':['侄孙眷妹'],
        'xb,s,s,w,xb':['侄孙眷孙男'],
        'xb,s,s,w,xb,w':['侄孙眷孙妇'],
        'xb,s,s,w,xs':['侄孙眷孙女'],
        'xb,s,s,w,xs,h':['侄孙眷孙婿'],
        'xb,s,s,s':['侄曾孙'],
        'xb,s,s,s,w':['侄曾孙妇'],
        'xb,s,s,s,s':['侄玄孙'],
        'xb,s,s,s,d':['侄玄孙女'],
        'xb,s,s,d':['侄曾孙女'],
        'xb,s,s,d,h':['侄曾孙婿'],
        'xb,s,s,d,s':['侄玄外孙'],
        'xb,s,s,d,d':['侄玄外孙女'],
        'xb,s,d':['侄孙女','从孙女'],
        'xb,s,d,h':['侄孙婿','从孙婿'],
        'xb,s,d,h,f':['侄孙姻男'],
        'xb,s,d,h,f,f&o':['侄孙姻兄'],
        'xb,s,d,h,f,f&l':['侄孙姻弟'],
        'xb,s,d,h,f,m&o':['侄孙姻姊'],
        'xb,s,d,h,f,m&l':['侄孙姻妹'],
        'xb,s,d,h,m':['侄孙姻女'],
        'xb,s,d,h,m,f&o':['侄孙姻兄'],
        'xb,s,d,h,m,f&l':['侄孙姻弟'],
        'xb,s,d,h,m,m&o':['侄孙姻姊'],
        'xb,s,d,h,m,m&l':['侄孙姻妹'],
        'xb,s,d,h,xb':['侄孙姻孙男'],
        'xb,s,d,h,xb,w':['侄孙姻孙妇'],
        'xb,s,d,h,xs':['侄孙姻孙女'],
        'xb,s,d,h,xs,h':['侄孙姻孙婿'],
        'xb,s,d,s':['侄曾外孙'],
        'xb,s,d,s,w':['侄曾外孙妇'],
        'xb,s,d,s,s':['侄曾外曾孙'],
        'xb,s,d,s,d':['侄曾外曾孙女'],
        'xb,s,d,d':['侄曾外孙女'],
        'xb,s,d,d,h':['侄曾外孙婿'],
        'xb,s,d,d,s':['侄曾外曾外孙'],
        'xb,s,d,d,d':['侄曾外曾外孙女'],
        'xb,d':['侄女','侄女儿','侄囡'],
        'xb,d,h':['侄女婿','侄婿'],
        'xb,d,h,f&o':['侄姻兄'],
        'xb,d,h,f&l':['侄姻弟'],
        'xb,d,h,f,f':['侄姻父'],
        'xb,d,h,f,m':['侄姻母'],
        'xb,d,h,m&o':['侄姻姊'],
        'xb,d,h,m&l':['侄姻妹'],
        'xb,d,h,m,f':['侄姻父'],
        'xb,d,h,m,m':['侄姻母'],
        'xb,d,h,xb':['侄姻男'],
        'xb,d,h,xb,w':['侄姻妇'],
        'xb,d,h,xs':['侄姻女'],
        'xb,d,h,xs,h':['侄姻婿'],
        'xb,d,s':['侄外孙','外侄孙'],
        'xb,d,s,w':['侄外孙妇','外侄孙妇'],
        'xb,d,s,w,f':['侄外孙眷男'],
        'xb,d,s,w,f,f&o':['侄外孙眷兄'],
        'xb,d,s,w,f,f&l':['侄外孙眷弟'],
        'xb,d,s,w,f,m&o':['侄外孙眷姊'],
        'xb,d,s,w,f,m&l':['侄外孙眷妹'],
        'xb,d,s,w,m':['侄外孙眷女'],
        'xb,d,s,w,m,f&o':['侄外孙眷兄'],
        'xb,d,s,w,m,f&l':['侄外孙眷弟'],
        'xb,d,s,w,m,m&o':['侄外孙眷姊'],
        'xb,d,s,w,m,m&l':['侄外孙眷妹'],
        'xb,d,s,w,xb':['侄外孙眷孙男'],
        'xb,d,s,w,xb,w':['侄外孙眷孙妇'],
        'xb,d,s,w,xs':['侄外孙眷孙女'],
        'xb,d,s,w,xs,h':['侄外孙眷孙婿'],
        'xb,d,s,s':['侄外曾孙'],
        'xb,d,s,s,w':['侄外曾孙妇'],
        'xb,d,s,s,s':['侄外玄孙'],
        'xb,d,s,s,d':['侄外玄孙女'],
        'xb,d,s,d':['侄外曾孙女'],
        'xb,d,s,d,h':['侄外曾孙婿'],
        'xb,d,s,d,s':['侄外玄外孙'],
        'xb,d,s,d,d':['侄外玄外孙女'],
        'xb,d,d':['侄外孙女','外侄孙女'],
        'xb,d,d,h':['侄外孙婿','外侄孙婿'],
        'xb,d,d,h,f':['侄外孙姻男'],
        'xb,d,d,h,f,f&o':['侄外孙姻兄'],
        'xb,d,d,h,f,f&l':['侄外孙姻弟'],
        'xb,d,d,h,f,m&o':['侄外孙姻姊'],
        'xb,d,d,h,f,m&l':['侄外孙姻妹'],
        'xb,d,d,h,m':['侄外孙姻女'],
        'xb,d,d,h,m,f&o':['侄外孙姻兄'],
        'xb,d,d,h,m,f&l':['侄外孙姻弟'],
        'xb,d,d,h,m,m&o':['侄外孙姻姊'],
        'xb,d,d,h,m,m&l':['侄外孙姻妹'],
        'xb,d,d,h,xb':['侄外孙姻孙男'],
        'xb,d,d,h,xb,w':['侄外孙姻孙妇'],
        'xb,d,d,h,xs':['侄外孙姻孙女'],
        'xb,d,d,h,xs,h':['侄外孙姻孙婿'],
        'xb,d,d,s':['侄外曾外孙'],
        'xb,d,d,s,w':['侄外曾外孙妇'],
        'xb,d,d,s,s':['侄外曾外曾孙'],
        'xb,d,d,s,d':['侄外曾外曾孙女'],
        'xb,d,d,d':['侄外曾外孙女'],
        'xb,d,d,d,h':['侄外曾外孙婿'],
        'xb,d,d,d,s':['侄外曾外曾外孙'],
        'xb,d,d,d,d':['侄外曾外曾外孙女'],
        // 姐妹
        'os':['姐姐','姐','阿姊','胞姐','大姐','阿姐','家姐','吖姐','x姐'],
        'os,h':['姐夫','姊夫','姊丈','姊婿','大姐夫','x姐夫'],
        'ls':['妹妹','妹','胞妹','老妹','阿妹','细妹','吖妹','x妹'],
        'ls,h':['妹夫','妹丈','妹婿','x妹夫'],
        'xs':['姐妹'],
        'xs,h,f':['姊妹姻父'],
        'xs,h,f,f':['姊妹姻祖父','姊妹姻奶爷','姊妹姻王父'],
        'xs,h,f,f,ob':['姊妹姻伯奶爷','姊妹姻伯王父'],
        'xs,h,f,f,ob,w':['姊妹姻伯奶奶','姊妹姻伯王母'],
        'xs,h,f,f,lb':['姊妹姻叔奶爷','姊妹姻叔王父'],
        'xs,h,f,f,lb,w':['姊妹姻叔奶奶','姊妹姻叔王母'],
        'xs,h,f,f,xs':['姊妹姻姑奶奶','姊妹姻姑王母'],
        'xs,h,f,f,xs,h':['姊妹姻姑奶爷','姊妹姻姑王父'],
        'xs,h,f,m':['姊妹姻祖母','姊妹姻奶奶','姊妹姻王母'],
        'xs,h,f,m,xb':['姊妹姻舅奶爷','姊妹姻舅王父'],
        'xs,h,f,m,xb,w':['姊妹姻舅奶奶','姊妹姻舅王母'],
        'xs,h,f,m,xs':['姊妹姻姨奶奶','姊妹姻姨王母'],
        'xs,h,f,m,xs,h':['姊妹姻姨奶爷','姊妹姻姨王父'],
        'xs,h,f,ob':['姊妹姻伯父'],
        'xs,h,f,ob,w':['姊妹姻伯母'],
        'xs,h,f,lb':['姊妹姻叔父'],
        'xs,h,f,lb,w':['姊妹姻叔母'],
        'xs,h,f,xb,s&o':['姊妹姻叔表兄'],
        'xs,h,f,xb,s&o,w':['姊妹姻叔表兄妇'],
        'xs,h,f,xb,s&l':['姊妹姻叔表弟'],
        'xs,h,f,xb,s&l,w':['姊妹姻叔表弟妇'],
        'xs,h,f,xb,d&o':['姊妹姻叔表姊'],
        'xs,h,f,xb,d&o,h':['姊妹姻叔表姊婿'],
        'xs,h,f,xb,d&l':['姊妹姻叔表妹'],
        'xs,h,f,xb,d&l,h':['姊妹姻叔表妹婿'],
        'xs,h,f,xs':['姊妹姻姑母'],
        'xs,h,f,xs,h':['姊妹姻姑父'],
        'xs,h,f,xs,s&o':['姊妹姻姑表兄'],
        'xs,h,f,xs,s&o,w':['姊妹姻姑表兄妇'],
        'xs,h,f,xs,s&l':['姊妹姻姑表弟'],
        'xs,h,f,xs,s&l,w':['姊妹姻姑表弟妇'],
        'xs,h,f,xs,d&o':['姊妹姻姑表姊'],
        'xs,h,f,xs,d&o,h':['姊妹姻姑表姊婿'],
        'xs,h,f,xs,d&l':['姊妹姻姑表妹'],
        'xs,h,f,xs,d&l,h':['姊妹姻姑表妹婿'],
        'xs,h,m':['姊妹姻母'],
        'xs,h,m,f':['姊妹姻外祖父','姊妹姻姥爷','姊妹姻王父'],
        'xs,h,m,f,ob':['姊妹姻伯姥爷','姊妹姻伯王父'],
        'xs,h,m,f,ob,w':['姊妹姻伯姥姥','姊妹姻伯王母'],
        'xs,h,m,f,lb':['姊妹姻叔姥爷','姊妹姻叔王父'],
        'xs,h,m,f,lb,w':['姊妹姻叔姥姥','姊妹姻叔王母'],
        'xs,h,m,f,xs':['姊妹姻姑姥姥','姊妹姻姑王母'],
        'xs,h,m,f,xs,h':['姊妹姻姑姥爷','姊妹姻姑王父'],
        'xs,h,m,m':['姊妹姻外祖母','姊妹姻姥姥','姊妹姻王母'],
        'xs,h,m,m,xb':['姊妹姻舅姥爷','姊妹姻舅王父'],
        'xs,h,m,m,xb,w':['姊妹姻舅姥姥','姊妹姻舅王母'],
        'xs,h,m,m,xs':['姊妹姻姨姥姥','姊妹姻姨王母'],
        'xs,h,m,m,xs,h':['姊妹姻姨姥爷','姊妹姻姨王父'],
        'xs,h,m,xb':['姊妹姻舅父'],
        'xs,h,m,xb,w':['姊妹姻舅母'],
        'xs,h,m,xb,s&o':['姊妹姻舅表兄'],
        'xs,h,m,xb,s&o,w':['姊妹姻舅表兄妇'],
        'xs,h,m,xb,s&l':['姊妹姻舅表弟'],
        'xs,h,m,xb,s&l,w':['姊妹姻舅表弟妇'],
        'xs,h,m,xb,d&o':['姊妹姻舅表姊'],
        'xs,h,m,xb,d&o,h':['姊妹姻舅表姊婿'],
        'xs,h,m,xb,d&l':['姊妹姻舅表妹'],
        'xs,h,m,xb,d&l,h':['姊妹姻舅表妹婿'],
        'xs,h,m,xs':['姊妹姻姨母'],
        'xs,h,m,xs,h':['姊妹姻姨父'],
        'xs,h,m,xs,s&o':['姊妹姻姨表兄'],
        'xs,h,m,xs,s&o,w':['姊妹姻姨表兄妇'],
        'xs,h,m,xs,s&l':['姊妹姻姨表弟'],
        'xs,h,m,xs,s&l,w':['姊妹姻姨表弟妇'],
        'xs,h,m,xs,d&o':['姊妹姻姨表姊'],
        'xs,h,m,xs,d&o,h':['姊妹姻姨表姊婿'],
        'xs,h,m,xs,d&l':['姊妹姻姨表妹'],
        'xs,h,m,xs,d&l,h':['姊妹姻姨表妹婿'],
        'xs,h,xb&o':['姊妹姻兄'],
        'xs,h,xb&o,w':['姊妹姻兄妇'],
        'xs,h,xb&l':['姊妹姻弟'],
        'xs,h,xb&l,w':['姊妹姻弟妇'],
        'xs,h,xb,s':['姊妹姻侄男'],
        'xs,h,xb,s,w':['姊妹姻侄妇'],
        'xs,h,xb,d':['姊妹姻侄女'],
        'xs,h,xb,d,h':['姊妹姻侄婿'],
        'xs,h,xs&o':['姊妹姻姊'],
        'xs,h,xs&o,h':['姊妹姻姊婿'],
        'xs,h,xs&l':['姊妹姻妹'],
        'xs,h,xs&l,h':['姊妹姻妹婿'],
        'xs,h,xs,s':['姊妹姻甥男'],
        'xs,h,xs,s,w':['姊妹姻甥妇'],
        'xs,h,xs,d':['姊妹姻甥女'],
        'xs,h,xs,d,h':['姊妹姻甥婿'],
        '0,xs,h,xb,s':['姨姻叔男'],
        '1,xs,h,xb,s':['姑姻叔男'],
        '0,xs,h,xb,d':['姨姻叔女'],
        '1,xs,h,xb,d':['姑姻叔女'],
        '0,xs,h,xs,s':['姨姻姑男'],
        '1,xs,h,xs,s':['姑姻姑男'],
        '0,xs,h,xs,d':['姨姻姑女'],
        '1,xs,h,xs,d':['姑姻姑女'],
        'xs,s':['外甥','外甥男','甥男','甥儿','甥子','外甥儿','外甥子','外甥儿子'],
        'xs,s,w':['外甥媳妇','甥媳妇','甥妇'],
        'xs,s,w,f&o':['甥眷兄'],
        'xs,s,w,f&l':['甥眷弟'],
        'xs,s,w,f,f':['甥眷父'],
        'xs,s,w,f,m':['甥眷母'],
        'xs,s,w,m&o':['甥眷姊'],
        'xs,s,w,m&l':['甥眷妹'],
        'xs,s,w,m,f':['甥眷父'],
        'xs,s,w,m,m':['甥眷母'],
        'xs,s,w,xb':['甥眷男'],
        'xs,s,w,xb,w':['甥眷妇'],
        'xs,s,w,xs':['甥眷女'],
        'xs,s,w,xs,h':['甥眷婿'],
        'xs,s,s':['甥孙','甥孙男','从孙男'],
        'xs,s,s,w':['甥孙妇','从孙妇'],
        'xs,s,s,w,f':['甥孙眷男'],
        'xs,s,s,w,f,f&o':['甥孙眷兄'],
        'xs,s,s,w,f,f&l':['甥孙眷弟'],
        'xs,s,s,w,f,m&o':['甥孙眷姊'],
        'xs,s,s,w,f,m&l':['甥孙眷妹'],
        'xs,s,s,w,m':['甥孙眷女'],
        'xs,s,s,w,m,f&o':['甥孙眷兄'],
        'xs,s,s,w,m,f&l':['甥孙眷弟'],
        'xs,s,s,w,m,m&o':['甥孙眷姊'],
        'xs,s,s,w,m,m&l':['甥孙眷妹'],
        'xs,s,s,w,xb':['甥孙眷孙男'],
        'xs,s,s,w,xb,w':['甥孙眷孙妇'],
        'xs,s,s,w,xs':['甥孙眷孙女'],
        'xs,s,s,w,xs,h':['甥孙眷孙婿'],
        'xs,s,s,s':['甥曾孙'],
        'xs,s,s,s,w':['甥曾孙妇'],
        'xs,s,s,s,s':['甥玄孙'],
        'xs,s,s,s,s':['甥玄孙女'],
        'xs,s,s,d':['甥曾孙女'],
        'xs,s,s,d,h':['甥曾孙婿'],
        'xs,s,s,d,s':['甥玄外孙'],
        'xs,s,s,d,d':['甥玄外孙女'],
        'xs,s,d':['甥孙女','从孙女'],
        'xs,s,d,h':['甥孙婿','从孙婿'],
        'xs,s,d,h,f':['甥孙姻男'],
        'xs,s,d,h,f,f&o':['甥孙姻兄'],
        'xs,s,d,h,f,f&l':['甥孙姻弟'],
        'xs,s,d,h,f,m&o':['甥孙姻姊'],
        'xs,s,d,h,f,m&l':['甥孙姻妹'],
        'xs,s,d,h,m':['甥孙姻女'],
        'xs,s,d,h,m,f&o':['甥孙姻兄'],
        'xs,s,d,h,m,f&l':['甥孙姻弟'],
        'xs,s,d,h,m,m&o':['甥孙姻姊'],
        'xs,s,d,h,m,m&l':['甥孙姻妹'],
        'xs,s,d,h,xb':['甥孙姻孙男'],
        'xs,s,d,h,xb,w':['甥孙姻孙妇'],
        'xs,s,d,h,xs':['甥孙姻孙女'],
        'xs,s,d,h,xs,h':['甥孙姻孙婿'],
        'xs,s,d,s':['甥曾外孙'],
        'xs,s,d,s,w':['甥曾外孙妇'],
        'xs,s,d,s,s':['甥曾外曾孙'],
        'xs,s,d,s,d':['甥曾外曾孙女'],
        'xs,s,d,d':['甥曾外孙女'],
        'xs,s,d,d,h':['甥曾外孙女'],
        'xs,s,d,d,s':['甥曾外曾外孙'],
        'xs,s,d,d,d':['甥曾外曾外孙女'],
        'xs,d':['外甥女','甥女','外甥囡'],
        'xs,d,h':['外甥女婿','甥女婿','甥婿'],
        'xs,d,h,f&o':['甥姻兄'],
        'xs,d,h,f&l':['甥姻弟'],
        'xs,d,h,f,f':['甥姻父'],
        'xs,d,h,f,m':['甥姻母'],
        'xs,d,h,m&o':['甥姻姊'],
        'xs,d,h,m&l':['甥姻妹'],
        'xs,d,h,m,f':['甥姻父'],
        'xs,d,h,m,m':['甥姻母'],
        'xs,d,h,xb':['甥姻男'],
        'xs,d,h,xb,w':['甥姻妇'],
        'xs,d,h,xs':['甥姻女'],
        'xs,d,h,xs,h':['甥姻婿'],
        'xs,d,s':['甥外孙'],
        'xs,d,s,w':['甥外孙妇'],
        'xs,d,s,w,f':['甥外孙眷男'],
        'xs,d,s,w,f,f&o':['甥外孙眷兄'],
        'xs,d,s,w,f,f&l':['甥外孙眷弟'],
        'xs,d,s,w,f,m&o':['甥外孙眷姊'],
        'xs,d,s,w,f,m&l':['甥外孙眷妹'],
        'xs,d,s,w,m':['甥外孙眷女'],
        'xs,d,s,w,m,f&o':['甥外孙眷兄'],
        'xs,d,s,w,m,f&l':['甥外孙眷弟'],
        'xs,d,s,w,m,m&o':['甥外孙眷姊'],
        'xs,d,s,w,m,m&l':['甥外孙眷妹'],
        'xs,d,s,w,xb':['甥外孙眷孙男'],
        'xs,d,s,w,xb,w':['甥外孙眷孙妇'],
        'xs,d,s,w,xs':['甥外孙眷孙女'],
        'xs,d,s,w,xs,h':['甥外孙眷孙婿'],
        'xs,d,s,s':['甥外曾孙'],
        'xs,d,s,s,w':['甥外曾孙妇'],
        'xs,d,s,s,s':['甥外玄孙'],
        'xs,d,s,s,d':['甥外玄孙女'],
        'xs,d,s,d':['甥外曾孙女'],
        'xs,d,s,d,h':['甥外曾孙婿'],
        'xs,d,s,d,s':['甥外玄外孙'],
        'xs,d,s,d,d':['甥外玄外孙女'],
        'xs,d,d':['甥外孙女'],
        'xs,d,d,h':['甥外孙婿'],
        'xs,d,d,h,f,f&o':['甥外孙姻兄'],
        'xs,d,d,h,f,f&l':['甥外孙姻弟'],
        'xs,d,d,h,f,m&o':['甥外孙姻姊'],
        'xs,d,d,h,f,m&l':['甥外孙姻妹'],
        'xs,d,d,h,m':['甥外孙姻女'],
        'xs,d,d,h,m,f&o':['甥外孙姻兄'],
        'xs,d,d,h,m,f&l':['甥外孙姻弟'],
        'xs,d,d,h,m,m&o':['甥外孙姻姊'],
        'xs,d,d,h,m,m&l':['甥外孙姻妹'],
        'xs,d,d,h,xb':['甥外孙姻孙男'],
        'xs,d,d,h,xb,w':['甥外孙姻孙妇'],
        'xs,d,d,h,xs':['甥外孙姻孙女'],
        'xs,d,d,h,xs,h':['甥外孙姻孙婿'],
        'xs,d,d,s':['甥外曾外孙'],
        'xs,d,d,s,w':['甥外曾外孙妇'],
        'xs,d,d,s,s':['甥外曾外曾孙'],
        'xs,d,d,s,d':['甥外曾外曾孙女'],
        'xs,d,d,d':['甥外曾外孙女'],
        'xs,d,d,d,h':['甥外曾外孙婿'],
        'xs,d,d,d,s':['甥外曾外曾外孙'],
        'xs,d,d,d,d':['甥外曾外曾外孙女'],
        //自家
        's':['儿子','男儿','儿','仔','阿仔','仔仔','x儿子'],
        's,w':['儿媳','儿媳妇','新妇'],
        's,s':['孙子','孙男','孙儿','x孙子'],
        's,s,w':['孙媳妇','孙媳','孙妇','孙新妇'],
        's,s,w,f':['孙眷男'],
        's,s,w,m':['孙眷女'],
        's,s,w,xb':['孙眷孙男','姻家再侄男','姻家再侄'],
        's,s,w,xb,w':['孙眷孙妇'],
        's,s,w,xs':['孙眷孙女','姻家再侄女','姻家再侄'],
        's,s,w,xs,h':['孙眷孙婿'],
        's,s,s':['曾孙','曾孙男','重孙','息仔'],
        's,s,s,w':['曾孙妇'],
        's,s,s,s':['玄孙','元孙','膀孙'],
        's,s,s,s,w':['玄孙媳妇'],
        's,s,s,s,s':['来孙'],
        's,s,s,s,s,w':['来孙媳妇'],
        's,s,s,s,s,s':['晜孙'],
        's,s,s,s,s,s,w':['晜孙媳妇'],
        's,s,s,s,s,s,s':['仍孙'],
        's,s,s,s,s,s,s,w':['仍孙媳妇'],
        's,s,s,s,s,s,s,s':['云孙'],
        's,s,s,s,s,s,s,s,s':['耳孙'],
        's,s,s,s,s,s,s,s,s,w':['耳孙媳妇'],
        's,s,s,s,s,s,s,s,d':['耳孙女'],
        's,s,s,s,s,s,s,s,d,h':['耳孙女婿'],
        's,s,s,s,s,s,s,d':['云孙女'],
        's,s,s,s,s,s,s,d,h':['云孙女婿'],
        's,s,s,s,s,s,s,d,s':['耳外孙'],
        's,s,s,s,s,s,s,d,s,w':['耳外孙媳妇'],
        's,s,s,s,s,s,s,d,d':['耳外孙女'],
        's,s,s,s,s,s,s,d,d,h':['耳外孙女婿'],
        's,s,s,s,s,s,d':['仍孙女'],
        's,s,s,s,s,s,d,h':['仍孙女婿'],
        's,s,s,s,s,s,d,s':['云外孙'],
        's,s,s,s,s,s,d,s,w':['云外孙媳妇'],
        's,s,s,s,s,s,d,d':['云外孙女'],
        's,s,s,s,s,s,d,d,h':['云外孙女婿'],
        's,s,s,s,s,d':['晜孙女'],
        's,s,s,s,s,d,h':['晜孙女婿'],
        's,s,s,s,s,d,s':['仍外孙'],
        's,s,s,s,s,d,s,w':['仍外孙媳妇'],
        's,s,s,s,s,d,d':['仍外孙女'],
        's,s,s,s,s,d,d,h':['仍外孙女婿'],
        's,s,s,s,d':['来孙女'],
        's,s,s,s,d,h':['来孙女婿'],
        's,s,s,s,d,s':['晜外孙'],
        's,s,s,s,d,s,w':['晜外孙媳妇'],
        's,s,s,s,d,d':['晜外孙女'],
        's,s,s,s,d,d,h':['晜外孙女婿'],
        's,s,s,d':['玄孙女'],
        's,s,s,d,h':['玄孙女婿'],
        's,s,s,d,s':['来外孙'],
        's,s,s,d,s,w':['来外孙媳妇'],
        's,s,s,d,d':['来外孙女'],
        's,s,s,d,d,h':['来外孙女婿'],
        's,s,d':['曾孙女','息女'],
        's,s,d,h':['曾孙女婿'],
        's,s,d,s':['玄外孙'],
        's,s,d,s,w':['玄外孙媳妇'],
        's,s,d,d':['玄外孙女'],
        's,s,d,d,h':['玄外孙女婿'],
        's,d':['孙女','孙囡'],
        's,d,h':['孙女婿','孙婿'],
        's,d,h,f':['孙姻男'],
        's,d,h,m':['孙姻女'],
        's,d,h,xb':['孙姻孙男','姻家再侄男','姻家再侄'],
        's,d,h,xb,w':['孙姻孙妇'],
        's,d,h,xs':['孙姻孙女','姻家再侄女','姻家再侄'],
        's,d,h,xs,h':['孙姻孙婿'],
        's,d,s':['曾外孙'],
        's,d,s,w':['曾外孙媳妇'],
        's,d,s,s':['曾外曾孙'],
        's,d,s,s,w':['曾外曾孙媳妇'],
        's,d,s,d':['曾外曾孙女'],
        's,d,s,d,h':['曾外曾孙女婿'],
        's,d,d':['曾外孙女'],
        's,d,d,h':['曾外孙女婿'],
        's,d,d,s':['曾外曾外孙'],
        's,d,d,s,w':['曾外曾外孙媳妇'],
        's,d,d,d':['曾外曾外孙女'],
        's,d,d,d,h':['曾外曾外孙女婿'],
        'd':['女儿','千金','闺女','掌上明珠','乖囡','囡囡','姑娘','女','阿女','女女','x女儿'],
        'd,h':['女婿','姑爷','女婿子','女婿儿','儿婿'],
        'd,s':['外孙'],
        'd,s,w':['外孙媳妇','外孙妇','外孙新妇'],
        'd,s,s':['外曾孙','重外孙'],
        'd,s,s,w':['外曾孙媳妇','外曾孙妇'],
        'd,s,s,s':['外玄孙'],
        'd,s,s,s,w':['外玄孙媳妇'],
        'd,s,s,d':['外玄孙女'],
        'd,s,s,d,h':['外玄孙女婿'],
        'd,s,d':['外曾孙女','重外孙女'],
        'd,s,d,h':['外曾孙女婿','重外孙女婿'],
        'd,s,d,s':['外玄外孙'],
        'd,s,d,s,w':['外玄外孙媳妇'],
        'd,s,d,d':['外玄外孙女'],
        'd,s,d,d,h':['外玄外孙女婿'],
        'd,d':['外孙女','外孙囡'],
        'd,d,h':['外孙女婿','外孙婿'],
        'd,d,s':['外曾外孙'],
        'd,d,s,w':['外曾外孙媳妇'],
        'd,d,s,s':['外曾外曾孙'],
        'd,d,s,s,w':['外曾外曾孙媳妇'],
        'd,d,s,d':['外曾外曾孙女'],
        'd,d,s,d,h':['外曾外曾孙女婿'],
        'd,d,d':['外曾外孙女'],
        'd,d,d,h':['外曾外孙女婿'],
        'd,d,d,s':['外曾外曾外孙'],
        'd,d,d,s,w':['外曾外曾外孙媳妇'],
        'd,d,d,d':['外曾外曾外孙女'],
        'd,d,d,d,h':['外曾外曾外孙女婿'],
        //亲家
        's,w,f':['亲家公','亲家翁','姻翁','亲家'],
        's,w,f&o':['男眷兄','息眷兄'],
        's,w,f&l':['男眷弟','息眷弟'],
        's,w,f,f':['男眷父','太姻翁'],
        's,w,f,f,f':['老太姻翁'],
        's,w,f,f,m':['老太姻姆'],
        's,w,f,f,ob':['男眷伯父','姻伯翁'],
        's,w,f,f,ob,w':['男眷伯母','姻伯姆'],
        's,w,f,f,lb':['男眷叔父','姻叔翁'],
        's,w,f,f,lb,w':['男眷叔母','姻叔姆'],
        's,w,f,f,xb,s&o':['男眷家兄'],
        's,w,f,f,xb,s&o,w':['男眷家兄妇'],
        's,w,f,f,xb,s&l':['男眷家弟'],
        's,w,f,f,xb,s&l,w':['男眷家弟妇'],
        's,w,f,f,xb,s,s':['男眷侄男'],
        's,w,f,f,xb,s,d':['男眷侄女'],
        's,w,f,f,xb,d&o':['男眷家姊'],
        's,w,f,f,xb,d&o,w':['男眷家姊婿'],
        's,w,f,f,xb,d&l':['男眷家妹'],
        's,w,f,f,xb,d&l,w':['男眷家妹婿'],
        's,w,f,f,xb,d,s':['男眷甥男'],
        's,w,f,f,xb,d,d':['男眷甥女'],
        's,w,f,m':['男眷母','太姻姆'],
        's,w,f,m,f':['老太姻翁'],
        's,w,f,m,m':['老太姻姆'],
        's,w,f,ob':['男眷叔兄'],
        's,w,f,ob,w':['男眷叔兄妇'],
        's,w,f,lb':['男眷叔弟'],
        's,w,f,lb,w':['男眷叔弟妇'],
        's,w,f,xb,s':['男眷叔男'],
        's,w,f,xb,d':['男眷叔女'],
        's,w,f,os':['男眷姑姊'],
        's,w,f,os,h':['男眷姑姊婿'],
        's,w,f,ls':['男眷姑妹'],
        's,w,f,ls,h':['男眷姑妹婿'],
        's,w,f,xs,s':['男眷姑男'],
        's,w,f,xs,d':['男眷姑女'],
        's,w,m':['亲家母','亲家姆','姻姆','亲家'],
        's,w,m&o':['男眷姊','息眷姊'],
        's,w,m&l':['男眷妹','息眷妹'],
        's,w,m,f':['男眷父','太姻翁'],
        's,w,m,m':['男眷母','太姻姆'],
        's,w,m,ob':['男眷舅兄'],
        's,w,m,ob,w':['男眷舅兄妇'],
        's,w,m,lb':['男眷舅弟'],
        's,w,m,lb,w':['男眷舅弟妇'],
        's,w,m,xb,s':['男眷舅男'],
        's,w,m,xb,d':['男眷舅女'],
        's,w,m,os':['男眷姨姊'],
        's,w,m,os,h':['男眷姨姊婿'],
        's,w,m,ls':['男眷姨妹'],
        's,w,m,ls,h':['男眷姨妹婿'],
        's,w,m,xs,s':['男眷姨男'],
        's,w,m,xs,d':['男眷姨女'],
        's,w,xb':['男眷男','息眷男'],
        's,w,xb,w':['男眷妇','息眷妇'],
        's,w,xb,s':['男眷孙男','息眷孙男'],
        's,w,xb,s,w':['男眷孙妇','息眷孙妇'],
        's,w,xb,d':['男眷孙女','息眷孙女'],
        's,w,xb,d,h':['男眷孙婿','息眷孙婿'],
        's,w,xs':['男眷女','息眷女'],
        's,w,xs,h':['男眷婿','息眷婿'],
        's,w,xs,s':['男眷外孙男','息眷外孙男'],
        's,w,xs,s,w':['男眷外孙妇','息眷外孙妇'],
        's,w,xs,d':['男眷外孙女','息眷外孙女'],
        's,w,xs,d,h':['男眷外孙婿','息眷外孙婿'],
        'd,h,f':['亲家公','亲家翁','姻翁','亲家'],
        'd,h,f&o':['女姻兄','息姻兄'],
        'd,h,f&l':['女姻弟','息姻弟'],
        'd,h,f,f':['女姻父','太姻翁'],
        'd,h,f,f,f':['老太姻翁'],
        'd,h,f,f,m':['老太姻姆'],
        'd,h,f,f,ob':['女姻伯父','姻伯翁'],
        'd,h,f,f,ob,w':['女姻伯母','姻伯姆'],
        'd,h,f,f,lb':['女姻叔父','姻叔翁'],
        'd,h,f,f,lb,w':['女姻叔母','姻叔姆'],
        'd,h,f,f,xb,s&o':['女姻家兄'],
        'd,h,f,f,xb,s&o,w':['女姻家兄妇'],
        'd,h,f,f,xb,s&l':['女姻家弟'],
        'd,h,f,f,xb,s&l,w':['女姻家弟妇'],
        'd,h,f,f,xb,s,s':['女姻侄男'],
        'd,h,f,f,xb,s,d':['女姻侄女'],
        'd,h,f,f,xb,d&o':['女姻家姊'],
        'd,h,f,f,xb,d&o,w':['女姻家姊婿'],
        'd,h,f,f,xb,d&l':['女姻家妹'],
        'd,h,f,f,xb,d&l,w':['女姻家妹婿'],
        'd,h,f,f,xb,d,s':['女姻甥男'],
        'd,h,f,f,xb,d,d':['女姻甥女'],
        'd,h,f,m':['女姻母','太姻姆'],
        'd,h,f,m,f':['老太姻翁'],
        'd,h,f,m,m':['老太姻姆'],
        'd,h,f,ob':['女姻叔兄'],
        'd,h,f,ob,w':['女姻叔兄妇'],
        'd,h,f,lb':['女姻叔弟'],
        'd,h,f,lb,w':['女姻叔弟妇'],
        'd,h,f,xb,s':['女姻叔男'],
        'd,h,f,xb,d':['女姻叔女'],
        'd,h,f,os':['女姻姑姊'],
        'd,h,f,os,h':['女姻姑姊婿'],
        'd,h,f,ls':['女姻姑妹'],
        'd,h,f,ls,h':['女姻姑妹婿'],
        'd,h,f,xs,s':['女姻姑男'],
        'd,h,f,xs,d':['女姻姑女'],
        'd,h,m':['亲家母','亲家姆','姻姆','亲家'],
        'd,h,m&o':['女姻姊','息姻姊'],
        'd,h,m&l':['女姻妹','息姻妹'],
        'd,h,m,f':['女姻父','太姻翁'],
        'd,h,m,m':['女姻母','太姻姆'],
        'd,h,m,ob':['女姻舅兄'],
        'd,h,m,ob,w':['女姻舅兄妇'],
        'd,h,m,lb':['女姻舅弟'],
        'd,h,m,lb,w':['女姻舅弟妇'],
        'd,h,m,xb,s':['女姻舅男'],
        'd,h,m,xb,d':['女姻舅女'],
        'd,h,m,os':['女姻姨姊'],
        'd,h,m,os,h':['女姻姨姊婿'],
        'd,h,m,ls':['女姻姨妹'],
        'd,h,m,ls,h':['女姻姨妹婿'],
        'd,h,m,xs,s':['女姻姨男'],
        'd,h,m,xs,d':['女姻姨女'],
        'd,h,xb':['女姻男','息姻男'],
        'd,h,xb,w':['女姻妇','息姻妇'],
        'd,h,xb,s':['女姻孙男','息姻孙男'],
        'd,h,xb,s,w':['女姻孙妇','息姻孙妇'],
        'd,h,xb,d':['女姻孙女','息姻孙女'],
        'd,h,xb,d,h':['女姻孙婿','息姻孙婿'],
        'd,h,xs':['女姻女','息姻女'],
        'd,h,xs,h':['女姻婿','息姻婿'],
        'd,h,xs,s':['女姻外孙男','息姻外孙男'],
        'd,h,xs,s,w':['女姻外孙妇','息姻外孙妇'],
        'd,h,xs,d':['女姻外孙女','息姻外孙女'],
        'd,h,xs,d,h':['女姻外孙婿','息姻外孙婿'],
    };

    // 模式
    var _data = Object.assign({},_map);
    var _mode = {};

    // 数组去重
    var unique = function(arr) {
        var result = [], hash = {};
        var item;
        for (var i = 0; (item = arr[i]) != null; i++) {
            var temp = item.replace(/[ol](?=s|b)/,'x').replace(/&[ol]/,''); //对特殊语法标识相互包含的行为去重
            if (temp==item&&!hash[temp]){
                hash[item] = true;
            }
        }
        for (var i = 0; (item = arr[i]) != null; i++) {
            var temp = item.replace(/[ol](?=s|b)/,'x').replace(/&[ol]/,''); //对特殊语法标识相互包含的行为去重
            if (temp!=item){
                if(!hash[temp]){
                    if(result.indexOf(item)==-1){
                        result.push(item);
                    }
                }
            }else{
                if(result.indexOf(item)==-1){
                    result.push(item);
                }
            }
        }
        return result;
    };

    // 中文获取选择器
    function getSelectors(str){
        str = str.replace(/[二|三|四|五|六|七|八|九|十]{1,2}/g,'x');
        var lists = str.replace(/我的?(.+)/,'$1').replace(/家的?/,'的').split('的');
        var result = [''];
        var isMatch = true;
        var replaceMap = {
            '哥':'兄',
            '姐':'姊',
            '媳':'妇',
            '夫':'婿',
            '姪':'侄',
            '姊妹姻':'姻',
            '女姻':'姻',
            '兄弟眷':'眷',
            '男眷':'眷'
        };
        var replaceMap2 = {
            '媳妇':'妇',
            '女婿':'婿'
        }
        while(lists.length){
            var name = lists.shift();           //当前匹配词
            var items = [];                     //当前匹配词可能性
            for(var i in _data){
                var value = _data[i];
                if(value.indexOf(name)>-1){     //是否存在该关系
                    items.push(i);
                }else{              //同义词替换
                    var r_name = name;
                    for(var word in replaceMap){
                        r_name = r_name.replace(word,replaceMap[word]);
                    }
                    for(var word in replaceMap2){
                        if(word!=name){
                            r_name = r_name.replace(word,replaceMap[word]);
                        }
                    }
                    var r_value = value.map(function(v){
                        for(var word in replaceMap){
                            v = v.replace(word,replaceMap[word]);
                        }
                        return v;
                    });
                    if(r_value.indexOf(r_name)>-1){
                        items.push(i);
                    }
                }
            }
            if(!items.length){
                isMatch = false;
            }
            var res = [];
            result.forEach(function(a){
                items.forEach(function(b){
                    res.push(a+(b?','+b:''));
                });
            });
            result = res;
        }
        return isMatch?result:[''];
    }

    // 选择器转ID
    function selector2id(selector,sex){
        var result = [];
        var hash = {};
        //性别判断
        if(sex<0){
            if(selector.match(/^,w/)){
                sex = 1;
            }else if(selector.match(/^,h/)){
                sex = 0;
            }
        }
        // console.log('[selector]',selector);
        var getId = function(selector,sex){
            if(selector.indexOf(',1')==-1&&selector.indexOf(',0')==-1){
                selector = ','+sex+selector;
            }
            if(selector.match(/,[w0],w|,[h1],h/)){  //同志关系去除
                return false;
            }
            var s='';
            if(!hash[selector]){
                hash[selector] = true;
                var status = true;
                do{
                    s = selector;
                    for(var i in _filter){
                        var item = _filter[i];
                        // console.log('[filter]',item['exp'],selector);
                        selector = selector.replace(item['exp'],item['str']);
                        if(selector.indexOf('#')>-1){
                            var arr = selector.split('#');
                            for(var j=0;j<arr.length;j++){
                                getId(arr[j]);
                            }
                            status=false;
                            break;
                        }
                    }
                }while(s!=selector);
                if(status){
                    if(selector.match(/,[w0],w|,[h1],h/)){  //同志关系去除
                        return false;
                    }
                    selector = selector.replace(/,[01]/,'').substr(1);  //去前面逗号和性别信息
                    result.push(selector);
                }
            }
        }
        if(sex<0){
            getId(selector,1);
            getId(selector,0);
        }else{
            getId(selector,sex);
        }
        return unique(result);
    }

    // 通过ID获取数据
    function getDataById(id){
        var items = [];
        var getData = function(d){
            var res = [];
            for(var i in _data){
                if(i.replace(/&[ol]/g,'')==d){
                    res.push(_data[i][0]);
                }else{
                    var expr = d;
                    while (expr.match(/[ol](b|s)/)){
                        expr = expr.replace(/[ol](b|s)/,'x$1');
                        if(expr==i){
                            res.push(_data[i][0]);
                            break;
                        }
                    }
                }
            }
            return res;
        };
        if(_data[id]){  // 直接匹配称呼
            items.push(_data[id][0]);
        }else{
            items = getData(id);
            // 忽略年龄条件查找
            if(!items.length){
                id = id.replace(/&[ol]/g,'');
                items = getData(id);
            }
            // 忽略年龄条件查找
            if(!items.length){
                id = id.replace(/[ol](b|s)/g,'x$1');
                items = getData(id);
            }
            // 缩小访问查找
            if(!items.length){
                var l = id.replace(/x/g,'l');
                items = getData(l);
                var o = id.replace(/x/g,'o');
                items = items.concat(getData(o));
            }
        }
        return items;
    }

    // 逆转ID
    function reverseId(id,sex){
        var hash = {
            f:['d','s'],
            m:['d','s'],
            h:['w',''],
            w:['','h'],
            s:['m','f'],
            d:['m','f'],
            lb:['os','ob'],
            ob:['ls','lb'],
            xb:['xs','xb'],
            ls:['os','ob'],
            os:['ls','lb'],
            xs:['xs','xb']
        };
        var age = '';
        if(id.match(/&o$/)){
            age = '&l';
        }else if(id.match(/&l$/)){
            age = '&o';
        }
        if(id){
            id = id.replace(/&[ol]/g,'');
            //性别判断
            if(sex<0){
                if(id.match(/^w/)){
                    sex = 1;
                }else if(id.match(/^h/)){
                    sex = 0;
                }
            }
            var result = [];
            var doing = function(sex){
                var sid = (','+sex+','+id).replace(/,[fhs]|,[olx]b/g,',1').replace(/,[mwd]|,[olx]s/g,',0');
                sid = sid.substring(0,sid.lastIndexOf(','));
                var id_arr = id.split(',').reverse();
                var sid_arr = sid.split(',').reverse();
                var arr = [];
                for(var i=0;i<id_arr.length;i++){
                    arr.push(hash[id_arr[i]][sid_arr[i]]);
                }
                var g = 0;
                var gMap = {'f':1,'m':1,'s':-1,'d':-1};
                arr.forEach(function(r){
                    g += gMap[r]||0;
                });
                return arr.join(',')+(g?'':age);
            };
            if(sex<0){
                result.push(doing(1));
                result.push(doing(0));
            }else{
                result.push(doing(sex));
            }
            return result;
        }
        return [''];
    }

    // 通过ID获取关系链条
    function getChainById(id){
        var arr = id.split(',');
        return arr.map(function(sign){
            var key = sign.replace(/&[ol]/,'');
            return _data[key][0];
        }).join('的');
    }

    // 合并选择器，查找两个对象之间的关系
    function mergeSelector(from,to,my_sex){
        if(my_sex<0){
            if(from.match(/^,w/)||to.match(/^,w/)){
                my_sex = 1;
            }else if(from.match(/^,h/)||to.match(/^,h/)){
                my_sex = 0;
            }
        }
        var sex = my_sex;
        var from_ids = selector2id(from,my_sex);
        var to_ids = selector2id(to,my_sex);
        var r_ids = [];
        if(to){
            var isMale = false;
            var isFemale = false;
            to_ids.forEach(function(id){
                if(id.match(/([fhs1](&[ol])?|[olx]b)$/)){
                    isMale = true;
                }
                if(id.match(/([mwd0](&[ol])?|[olx]s)$/)){
                    isFemale = true;
                }
                r_ids = r_ids.concat(reverseId(id,my_sex));
            });
            r_ids = unique(r_ids);
            if(isMale&&isFemale){
                sex = -1;
            }else if(isMale){
                sex = 1;
            }else if(isFemale){
                sex = 0;
            }
        }else{
            r_ids = [''];
        }
        // console.log('[from_ids]',from_ids,'r_ids',r_ids);
        var from_selector = from_ids.length>1?'['+from_ids.join('|')+']':from_ids[0];
        var to_selector = r_ids.length>1?'['+r_ids.join('|')+']':r_ids[0];
        return {
            'selector':(to?','+to_selector:'')+(from?','+from_selector:''),
            'sex':sex
        };
    }

    var relationship = function (parameter){
        var options = Object.assign({
            text:'',
            target:'',
            sex:-1,
            type:'default',     // 'chain'表示关系链
            reverse:false,    // true表示反向
            mode:'default',   // 用户自定义模式
        },parameter);
        _data = Object.assign({},_map);
        for(var lang in _mode){
            if(options.mode==lang){
                for(var key in _mode[lang]){
                    _data[key] = [].concat(_mode[lang][key],_map[key]||[]);
                }
            }
        }
        var from_selectors = getSelectors(options.text);
        var to_selectors = getSelectors(options.target);
        // console.log('[selectors]',from_selectors,to_selectors);
        var result = [];                            //匹配结果
        from_selectors.forEach(function(from){
            to_selectors.forEach(function(to){
                var data = mergeSelector(from,to,options.sex);
                // console.log('[data]',data);
                var ids = selector2id(data['selector'],data['sex']);
                // console.log('[ids]',data['selector'],data['sex'],ids);
                if(ids){
                    ids.forEach(function(id){
                        var temps = [id];
                        if(options.type=='chain'){
                            if(options.reverse){
                                temps = reverseId(id,data['sex']);
                            }
                            temps.forEach(function(id){
                                var item = getChainById(id);
                                if(item){
                                    result.push(item);
                                }
                            });
                        }else{
                            if(options.reverse){
                                temps = reverseId(id,data['sex']);
                            }
                            temps.forEach(function(id){
                                var items = getDataById(data['sex']+','+id);
                                if(!items.length){
                                    items = getDataById(id);
                                }
                                if(!items.length){
                                    if(id.indexOf('w')==0||id.indexOf('h')==0){  //找不到关系，随爱人叫
                                        items = getDataById(id.substr(2));
                                    }
                                }
                                if(items.length){
                                    result = result.concat(items);
                                }
                            });
                        }
                    });
                }
            });
        });
        return unique(result);
    };

    // 数据量
    relationship.dataCount = 0;
    for(var i in _data){
        relationship.dataCount++;
    }
    // 设置语言模式
    relationship.setMode = function(sign,data){
        if(typeof _mode[sign]=='undefined'){
            _mode[sign] = {};
        }
        _mode[sign] = Object.assign(_mode[sign],data);
    };
    return relationship;
});
